/**
 * 转公文模块对象
 * 
 * @param {Object}
 *            params
 */

var GovdocApi = function() {

	// controller配置信息
	this.config = {
		controller : "/seeyon" + "/govdoc/govdoc.do?method=newGovdoc"
	};

	// 创建协同传入的参数
	this.clearData();

	// 新建公文win
	this.newGovdocWin = null;

	// 新建协同窗口名字
	this.newGovdocWinName = "newGovdocWin" + (new Date()).getTime();
};

GovdocApi.prototype.clearData = function() {

	this.parameters = {

		subject : "",// 标题
		bodyType : '10',// 正文类型，MainbodyType
		// HTML(10),FORM(20),TXT(30),OfficeWord(41),OfficeExcel(42),
		// WpsWord(43), WpsExcel(44),Pdf(45);
		bodyContent : '',// 正文内容, 如果是非HTML正文，这里是id
		manual : "false",// 是否通过后台代码设置协同正文
		personId : '',// 流程人员ID，目前只有人员卡片用到
		from : '',// 和原来逻辑保持一致
		sub_app : '1', //公文类型 1发文，2收文，3签报，4交换

		// 以下参数用户在后台获取参数的
		handlerName : '',// 手动设置正文或需要获取附件的Handler
		sourceId : '',// 业务对应ID，各个模块自己设置，用于获取附件或正文
		ext : ''// 扩展信息，用户sourceId不够的情况使用
	};
}

/**
 * 新建公文，传入参数
 */
GovdocApi.prototype.newGovdoc = function(params) {

	// 初始化页面
	this.init(params);

	// 提交参数
	if (this.newGovdocWin && !this.newGovdocWin.closed) {
		alert($.i18n('window.already.exit.js'));//该页面已打开
		this.newGovdocWin.focus();
	} else {
		this.ajaxSubmit();
	}
};

// Post方式提交表单
GovdocApi.prototype.ajaxSubmit = function() {
    var _this = this;
	// 先声明一个异步请求对象
	var xmlHttpReg = null;
	if (window.ActiveXObject) {// 如果是IE
		xmlHttpReg = new ActiveXObject("Microsoft.XMLHTTP");
	} else if (window.XMLHttpRequest) {
		xmlHttpReg = new XMLHttpRequest(); // 实例化一个xmlHttpReg
	}
	// 如果实例化成功,就调用open()方法,就开始准备向服务器发送请求
	if (xmlHttpReg != null) {
	    xmlHttpReg.onreadystatechange = function(){
	        if (xmlHttpReg.readyState == 4 && xmlHttpReg.status == 200) {//4代表执行完成
	        	var cashId = xmlHttpReg.responseText
	            _this.openWindow(cashId);
	        }
	    };
	    xmlHttpReg.open("POST", "/seeyon/govdoc/govdoc.do?method=cashTransData&trans_AppToGovdoc=true&_rand=" + new Date().getTime()+ getA8Top().CsrfGuard.getUrlSurffix(), true);
	    xmlHttpReg.setRequestHeader("Content-Type","application/x-www-form-urlencoded; charset=UTF-8"); 
	    xmlHttpReg.send(this.formDatas());
	}
};

/**
 * 组装数据
 */
GovdocApi.prototype.formDatas = function(){
    
    var d = {};
    for(var key in this.parameters){
        var v = this.parameters[key];
        if(v != null && v != ""){
            d[key] = v;
        }
    }
    return this.formatParams(d);
}

/**
 * 格式化数据
 */
GovdocApi.prototype.formatParams = function(data) {
    var arr = [];
    for ( var name in data) {
        arr.push(encodeURIComponent(name) + "=" + encodeURIComponent(data[name]));
    }
    return arr.join("&");
}


GovdocApi.prototype.openWindow = function(cashId) {

	var width = parseInt(screen.width) - 20;
	var height = parseInt(screen.height) - 80;

	height -= 25;

	var win = window.open(this.config.controller + "&from=trans&cashId=" + cashId + getA8Top().CsrfGuard.getUrlSurffix(),
			this.newCollWinName,
			"top=0,left=0,scrollbars=yes,dialog=yes,minimizable=yes,modal=open,width="
					+ width + ",height=" + height + ",resizable=yes");
	if (win == null) {
		return;
	}

	this.newGovdocWin = win;

	win.focus();
	return win;
};

/**
 * 初始化函数
 * 
 * @param {Object}
 *            params
 */
GovdocApi.prototype.init = function(params) {

	this.clearData();

	// 参数覆盖TODO
	if (params) {
		for ( var key in params) {
			if (this.parameters[key] != undefined) {
				this.parameters[key] = params[key];
			}
		}
	}
};

/**
 * 创建元素
 * 
 * @param formEle
 *            form元素
 * @param eleName
 *            input Name
 * @param eleValue
 *            input alue
 * @returns
 */
GovdocApi.prototype.createNewFormElement = function(formEle, eleName,
		eleValue, tagName) {
	if (!tagName) {
		tagName = "input";
	}

	var newEle = document.createElement(tagName);
	newEle.setAttribute("name", eleName);
	if (tagName == "input") {
		newEle.setAttribute("type", "hidden");
	} else {
		newEle.style.display = "none";
	}
	newEle.value = eleValue;
	formEle.appendChild(newEle);
	return newEle;
};



// 创建全局变量
var govdocApi = new GovdocApi();