var topSearchSize = 7;

/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadToolbar();
	loadSearch();
	loadData();
});

/**
 * 加载页面布局
 */
function loadUE() {
	new MxtLayout({
		'id' : 'layout',
		'northArea' : {
			'id' : 'north',
			'height' : 40,
			'sprit' : false,
			'border' : false
		},
		'centerArea' : {
			'id' : 'center',
			'border' : false,
			'minHeight' : 20
		}
	});
}

function loadToolbar() {
	var toolbarArray = new Array();
	//新建
	var subMenus =  new Array(); 
	subMenus.push({id : "reserveUpBtn", name : $.i18n('edoc.doctemplate.text.title'), className : "ico16 reserve_16", click : function() { createDocTemplate('0');} });
	subMenus.push({id : "reserveDownBtn", name : $.i18n('edoc.doctemplate.wendan.title'), className : "ico16 reserve_16", click : function() { createDocTemplate('1'); } });
	toolbarArray.push({//新建
		id : "newBtn",
		name : $.i18n('common.toolbar.new.label'),
		className : "ico16",
		subMenu : subMenus
	});
	toolbarArray.push({//修改
		id : "modifyBtn",
		name : $.i18n('common.toolbar.update.label'),
		className : "ico16 editor_16",
		click: editDocTemplate
	});
	toolbarArray.push({//删除
		id : "deleteBtn",
		name : $.i18n('common.toolbar.delete.label'),
		className : "ico16 del_16",
		click: deleteDocTemplate
	});
	toolbarArray.push({//下载模板
		id : "downBtn",
		name : $.i18n('edoc.doctemplate.download'),
		className : "ico16",
		click: download
	});
	// 工具栏
	$("#toolbars").toolbar({
		toolbar : toolbarArray
	});
}

/**
 * 加载列表小查询
 */
function loadSearch() {
	var conditionArray = new Array();
	conditionArray.push({// 套红模板名称
		id : 'name',
		name : 'name',
		type : 'input',
		text : $.i18n("edoc.form.name"),
		value : 'name',
		maxLength : 100
	});
	
	var statusItems = new Array();
	statusItems.push({text : $.i18n("edoc.element.enabled"), value : '1' });// 是
	statusItems.push({text : $.i18n("edoc.element.disabled"), value : '0' });// 否
	conditionArray.push({// 套红模板状态
		id : 'status',
		name : 'status',
		type : 'select',
		text : $.i18n("edoc.form.status"),
		value : 'status',
		items: statusItems
	});
	
	var typeItems = new Array();
	typeItems.push({text : $.i18n("edoc.doctemplate.text"), value : '0' });// 正文套红模板
	typeItems.push({text : $.i18n("edoc.doctemplate.wendan"), value : '1' });// 文单套红模板
	conditionArray.push({// 套红模板类型
		id : 'type',
		name : 'type',
		type : 'select',
		text : $.i18n("edoc.doctemplate.type"),
		value : 'type',
		items: typeItems
	});
	
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 50,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose === 'name') {//名称
		o.name = $('#name').val();
	} else if (choose == 'status') {// 状态
		o.status = $('#status').val();
	} else if (choose == 'type') {// 类型
		o.type = $('#type').val();
	}
	o.condition = "choose";
	return o;
}

var grid;
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : 'objTeamId',
		name : 'id',
		value : 'id',
		domainId : 'orgAccountId',
		width : '5%',
		type : 'checkbox',
		isToggleHideShow : false
	});
	colModels.push({//类型
		display : $.i18n("edoc.doctemplate.type"),
		name : 'type',
		sortable : true,
		width : '10%'
	});
	colModels.push({//模板名称
		display : $.i18n("edoc.doctemplate.name"),
		name : 'name',
		sortable : true,
		width : '34%'
	});
	colModels.push({//授权
		display : $.i18n("edoc.doctemplate.grant"),
		name : 'grantNames',
		sortable : true,
		width : '40%'
	});
	colModels.push({
		display : $.i18n("edoc.form.status"),
		name : 'status',
		sortable : true,
		width : '10%'
	});

	//构造列表
    grid = $('#docTemplateList').ajaxgrid({
       click: clickRow,
       dblclick: dbclickRow,
       colModel: colModels,
       height: 200,
       render : rend,
       showTableToggleBtn: true,
       parentId: $('.layout_center').eq(0).attr('id'),
       vChange: true,
       isHaveIframe:true,
       slideToggleBtn:true,
       onSuccess:function() {
       		loadDesc();
       },
       managerName : "govdocDocTemplateManager",
       managerMethod : "findList"
    });
    
    var o = new Object();
    searchByCondition(o);
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#docTemplateList").ajaxgridLoad(o);
}

function rend(txt, data, r, c, col) {
	if (null == txt) {
		txt = "";
	}
	if(col.name == "name") {
		if(data.textType == "officeword") {
			txt = txt + '<span class="ico16 doc_16"></span>';
		} else {
			txt = txt + '<span class="ico16 wps_16"></span>';
		}
	} else if(col.name == "type") {
		if(data.type == "0") {
			txt = $.i18n("edoc.doctemplate.text");
		} else {
			txt = $.i18n("edoc.doctemplate.wendan");
		}
	} else if(col.name == "status") {
		if(data.status == "1") {
			txt = $.i18n("edoc.element.enabled");
		} else {
			txt = $.i18n("edoc.element.disabled");
		}
	}
	return txt;
}

function clickRow(data, rowIndex, colIndex) {
	editDocTemplate("readonly", data.id);
}

function dbclickRow(data, rowIndex, colIndex) {
	editDocTemplate("edit", data.id);
}

function createDocTemplate(type) {
	loadDesc(docTemplateURL + "?method=newTemplate&type=" + type);
}

function editDocTemplate(flag, docTemplateId) {
	if(!docTemplateId) {
		var rows = grid.grid.getSelectRows();
		if(rows.length == 0) {
			$.alert(v3x.getMessage("edocLang.templete_alertSelectTemplete"));
			return ;
		} else if(rows.length > 1) {
			$.alert(v3x.getMessage('edocLang.docTemplate_alter_select_one'));
			return ;
		}
		flag = "edit";
		docTemplateId = rows[0].id;
	}
	
	var aUrl = docTemplateURL + "?method=edit&flag=" + flag + "&id=" + docTemplateId;
	loadDesc(aUrl);
}

function loadDesc(url, updown) {
	if($.trim(grid) != "" && $.trim(grid.p) != "") {
		if(!url) {
            url = "";
		} else {
			updown = "middle";
		}
		if(!updown) {
			updown = "down";
		}
		grid.grid.resizeGridUpDown(updown);
	}
	$('#summary').attr("src", url);
}

//刷新父页面
function reloadList() {
	var listObj = $("#docTemplateList");
	if(listObj[0])  {//如果从列表中打开，则刷新列表
		try {
			searchByCondition(new Object());
			loadDesc();
		} catch(e) {
			location.href = docTemplateURL + "?method=list";	
		}
	} else {
		location.href = docTemplateURL + "?method=list";
	}
}


function deleteDocTemplate() {
	var rows = grid.grid.getSelectRows();
	if(rows.length == 0) {
		$.alert(v3x.getMessage("edocLang.templete_alertSelectTemplete"));
		return ;
	}
	
	if(window.confirm(_("edocLang.templete_confirmDeleteTemplete"))) {
		var ids = "";
		for(var i=0; i<rows.length; i++) {
			ids += rows[i].id + ",";
		}
		ids = ids.substring(0, ids.length - 1);
		document.location.href = docTemplateURL + '?method=delete&id=' + ids;
	}
}

function download() {
	if (fileId == '' || fileId == null) {
		alert(v3x.getMessage("edocLang.edoc_file_noExist"));
		return;
	}
	var name = encodeURI(fileName);
	var downloadUrl = "/seeyon/fileDownload.do?method=download&fileId=" + fileId + "&v=" + vFileId + "&isSystemRedTemplete=true&createDate=" + createDate + "&filename=" + name;
	mainForm.action = downloadUrl;
	mainForm.target = "temp_frame";
	mainForm.submit();
	mainForm.action = "";
}
