var topSearchSize = 7;

/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadToolbar();
	loadSearch();
	loadData();
});

/**
 * 加载页面布局
 */
function loadUE() {
	new MxtLayout({
		'id' : 'layout',
		'northArea' : {
			'id' : 'north',
			'height' : 40,
			'sprit' : false,
			'border' : false
		},
		'centerArea' : {
			'id' : 'center',
			'border' : false,
			'minHeight' : 20
		}
	});
}

function loadToolbar() {
	var toolbarArray = new Array();
	//新建
	/*var subMenus =  new Array(); 
	subMenus.push({id : "reserveUpBtn", name : $.i18n('edoc.doctemplate.text.title'), className : "ico16 reserve_16", click : function() { createDocTemplate('0');} });
	subMenus.push({id : "reserveDownBtn", name : $.i18n('edoc.doctemplate.wendan.title'), className : "ico16 reserve_16", click : function() { createDocTemplate('1'); } });
	toolbarArray.push({//新建
		id : "newBtn",
		name : $.i18n('common.toolbar.new.label'),
		className : "ico16",
		subMenu : subMenus
	});*/
	toolbarArray.push({//修改
		id : "modifyBtn",
		name : $.i18n('common.toolbar.update.label'),
		className : "ico16 editor_16",
		click: editOneElement
	});
	/*toolbarArray.push({//删除
		id : "deleteBtn",
		name : $.i18n('common.toolbar.delete.label'),
		className : "ico16 del_16",
		click: deleteDocTemplate
	});*/
	toolbarArray.push({//下载模板
		id : "downBtn",
		name : $.i18n('common.toolbar.exportExcel.label'),
		className : "ico16 export_excel_16",
		click: exportElement
	});
	// 工具栏
	$("#toolbars").toolbar({
		toolbar : toolbarArray
	});
}

function editOneElement(){
	editElement(undefined, "edit");
}

/**
 * 加载列表小查询
 */
function loadSearch() {
	var conditionArray = new Array();
	conditionArray.push({// 名称
		id : 'elementName',
		name : 'elementName',
		type : 'input',
		text : $.i18n("edoc.element.elementName"),
		value : 'elementName',
		maxLength : 100
	});
	
	conditionArray.push({// field名称
		id : 'elementfieldName',
		name : 'elementfieldName',
		type : 'input',
		text : $.i18n("edoc.element.elementfieldName"),
		value : 'elementfieldName',
		maxLength : 100
	});
	
	/*var statusItems = new Array();
	statusItems.push({text : $.i18n("edoc.element.enabled"), value : '1' });// 是
	statusItems.push({text : $.i18n("edoc.element.disabled"), value : '0' });// 否
	conditionArray.push({// 套红模板状态
		id : 'status',
		name : 'status',
		type : 'select',
		text : $.i18n("edoc.form.status"),
		value : 'status',
		items: statusItems
	});
	
	var typeItems = new Array();
	typeItems.push({text : $.i18n("edoc.doctemplate.text"), value : '0' });// 正文套红模板
	typeItems.push({text : $.i18n("edoc.doctemplate.wendan"), value : '1' });// 文单套红模板
	conditionArray.push({// 套红模板类型
		id : 'type',
		name : 'type',
		type : 'select',
		text : $.i18n("edoc.doctemplate.type"),
		value : 'type',
		items: typeItems
	});*/
	
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 50,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				o.page = 1;
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose === 'elementName') {//名称
		o.textfield = $('#elementName').val();
	} else if (choose == 'elementfieldName') {// 状态
		o.textfield = $('#elementfieldName').val();
	}
	o.condition = choose;
	return o;
}

var grid;
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : 'elementId',
		name : 'id',
		value : 'id',
		domainId : 'elementId',
		width : '5%',
		type : 'checkbox',
		isToggleHideShow : false
	});
	colModels.push({//类型
		display : $.i18n("edoc.element.elementName"),
		name : 'name',
		sortable : true,
		width : '20%'
	});
	colModels.push({//模板名称
		display : $.i18n("edoc.element.elementfieldName"),
		name : 'fieldName',
		sortable : true,
		width : '34%'
	});
	colModels.push({//授权
		display : $.i18n("edoc.element.elementType"),
		name : 'type',
		sortable : true,
		width : '20%'
	});
	colModels.push({
		display : $.i18n("edoc.element.elementIsSystem"),
		name : 'isSystem',
		sortable : true,
		width : '20%'
	});

	//构造列表
    grid = $('#elementList').ajaxgrid({
       click: clickRow,
       dblclick: clickRow,
       colModel: colModels,
       height: 200,
       render : rend,
       showTableToggleBtn: true,
       parentId: $('.layout_center').eq(0).attr('id'),
       vChange: true,
       isHaveIframe:true,
       slideToggleBtn:true,
       onSuccess:function() {
       		loadDesc();
       },
       managerName : "govdocElementManager",
       managerMethod : "findList"
    });
    
    var o = new Object();
    o.page = page;
    o.size = size;
    searchByCondition(o);
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#elementList").ajaxgridLoad(o);
}

function rend(txt, data, r, c, col) {
	if (null == txt) {
		txt = "";
	}
	if(col.name == "type") {
		if(data.type == "0") {
			txt = $.i18n("edoc.element.string");
		} else if(data.type == "1") {
			txt = $.i18n("edoc.element.text");
		}else if(data.type == "2") {
			txt = $.i18n("edoc.element.integer");
		}else if(data.type == "3") {
			txt = $.i18n("edoc.element.decimal");
		}else if(data.type == "4") {
			txt = $.i18n("edoc.element.date");
		}else if(data.type == "5") {
			txt = $.i18n("edoc.element.list");
		}else if(data.type == "6") {
			txt = $.i18n("edoc.element.comment");
		}else if(data.type == "7") {
			txt = $.i18n("edoc.element.img");
		}
	} else if(col.name == "isSystem") {
		if(data.isSystem == true) {
			txt = $.i18n("edoc.element.systemType");
		} else {
			txt = $.i18n("edoc.element.userType");
		}
	}
	return txt;
}

function clickRow(data, rowIndex, colIndex) {
	editElement(data.elementId, "view");
}

function editElement(id, flag) {
	if(!id) {
		var rows = grid.grid.getSelectRows();
		if(rows.length == 0) {
			$.alert(v3x.getMessage("edocLang.element_alter_not_select"));
			return ;
		} else if(rows.length > 1) {
			$.alert(v3x.getMessage('edocLang.element_alter_select_one'));
			return ;
		}
		flag = "edit";
		id = rows[0].elementId;
	}
	var editMode = flag;
	var aUrl = edocElementURL + "?method=editPage&flag=" + editMode;
	aUrl += "&id=" + id;
	aUrl += "&page=" + grid.grid.options.page;
	aUrl += "&size=" + grid.grid.options.rp;
	loadDesc(aUrl);
}


function loadDesc(url, updown) {
	if($.trim(grid) != "" && $.trim(grid.p) != "") {
		if(!url) {
            url = "";
		} else {
			updown = "middle";
		}
		if(!updown) {
			updown = "down";
		}
		grid.grid.resizeGridUpDown(updown);
	}
	$('#summary').attr("src", url);
}

function exportElement() {
	var obj = getConditionObj();
	var exportValue = '';
	if ('' != obj.condition && null!= obj.condition) {
		exportValue = obj.condition;
	}
	var conditionValue = '';
	if ('' != obj.textfield && null != obj.textfield) {
		conditionValue = obj.textfield;
	}
	var downloadUrl = edocElementURL + "?method=exportElementToExcel&exportValue="
			+ exportValue + "&conditionValue=" + encodeURIComponent(conditionValue);
	mainForm.action = downloadUrl;
	mainForm.method = "post";
	mainForm.target = "temp_frame";
	mainForm.submit();
	mainForm.action = "";
}

function download() {
	if (fileId == '' || fileId == null) {
		alert(v3x.getMessage("edocLang.edoc_file_noExist"));
		return;
	}
	var name = encodeURI(fileName);
	var downloadUrl = "/seeyon/fileDownload.do?method=download&fileId=" + fileId + "&v=" + vFileId + "&isSystemRedTemplete=true&createDate=" + createDate + "&filename=" + name;
	mainForm.action = downloadUrl;
	mainForm.target = "temp_frame";
	mainForm.submit();
	mainForm.action = "";
}
