var topSearchSize = 7;

/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadToolbar();
	loadSearch();
	loadData();
});

/**
 * 加载页面布局
 */
function loadUE() {
	new MxtLayout({
		'id' : 'layout',
		'northArea' : {
			'id' : 'north',
			'height' : 40,
			'sprit' : false,
			'border' : false
		},
		'centerArea' : {
			'id' : 'center',
			'border' : false,
			'minHeight' : 20
		}
	});
}

function loadToolbar() {
	var toolbarArray = new Array();
	toolbarArray.push({//新建
		id : "newBtn",
		name : $.i18n('common.toolbar.new.label'),
		className : "ico16",
		click: newItem
	});
	toolbarArray.push({//修改
		id : "modifyBtn",
		name : $.i18n('common.toolbar.update.label'),
		className : "ico16 editor_16",
		click: editOneElement
	});
	toolbarArray.push({//删除
		id : "deleteBtn",
		name : $.i18n('common.toolbar.delete.label'),
		className : "ico16 del_16",
		click: deleteItem
	});
	// 工具栏
	$("#toolbars").toolbar({
		toolbar : toolbarArray
	});
}

function editOneElement(){
	editItem(undefined, "edit");
}

/**
 * 加载列表小查询
 */
function loadSearch() {
	var conditionArray = new Array();
	conditionArray.push({// 名称
		id : 'unitName',
		name : 'unitName',
		type : 'input',
		text : $.i18n("edoc.form.name"),
		value : 'unitName',
		maxLength : 100
	});

	
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 50,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				o.page = 1;
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose === 'unitName') {//名称
		o.textfield = $('#unitName').val();
	}
	o.condition = choose;
	return o;
}

var grid;
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : 'accId',
		name : 'id',
		value : 'id',
		domainId : 'accId',
		width : '5%',
		type : 'checkbox',
		isToggleHideShow : false
	});
	colModels.push({//名称
		display : $.i18n("common.name.label"),
		name : 'name',
		sortable : true,
		width : '30%'
	});
	colModels.push({//描述
		display : $.i18n("common.description.label"),
		name : 'description',
		sortable : true,
		width : '64%'
	});

	//构造列表
    grid = $('#exAccountList').ajaxgrid({
       click: clickRow,
       dblclick: clickRow,
       colModel: colModels,
       height: 200,
       render : rend,
       showTableToggleBtn: true,
       parentId: $('.layout_center').eq(0).attr('id'),
       vChange: true,
       isHaveIframe:true,
       slideToggleBtn:true,
       onSuccess:function() {
       		loadDesc();
       },
       managerName : "govdocExchangeAccountManager",
       managerMethod : "findList"
    });
    
    var o = new Object();
    searchByCondition(o);
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#exAccountList").ajaxgridLoad(o);
}

function rend(txt, data, r, c, col) {
	if (null == txt) {
		txt = "";
	}
	return txt;
}

function deleteItem() {
	var rows = grid.grid.getSelectRows();
	if(rows.length == 0) {
		$.alert(v3x.getMessage("ExchangeLang.outter_unit_alter_not_select"));
		return ;
	}
	//var checkedIds = document.getElementsByName('id');
	var len = rows.length;
	var str = "";
	for (var i = 0; i < len; i++) {
		var checkedId = rows[i];
		if (checkedId) {
			str += checkedId.id;
			str += ","
		}
	}
	$.confirm({
		'msg' : v3x.getMessage('ExchangeLang.outter_unit_alter_delete_confirm'),//确认要删除该模版分类？该操作不能恢复
		ok_fn : function() {
			str = str.substring(0, str.length - 1);
			$("#temp_frame").prop("src",exchangeAccountURL + '?method=deleteExchangeAccount&id=' + str);
		}
	});
}
function newItem(){
	var aUrl = exchangeAccountURL + "?method=addExchangeAccountPage";
	loadDesc(aUrl);
}

function clickRow(data, rowIndex, colIndex) {
	editItem(data.id, "view");
}
function editItem(id,flag) {
	if(!id) {
		var rows = grid.grid.getSelectRows();
		if(rows.length == 0) {
			$.alert(v3x.getMessage("ExchangeLang.outter_unit_alter_not_select"));
			return ;
		} else if(rows.length > 1) {
			$.alert(v3x.getMessage('ExchangeLang.outter_unit_alter_select_one'));
			return ;
		}
		flag = "edit";
		id = rows[0].id;
	}
	var aUrl = exchangeAccountURL + "?method=editExchangeAccountPage&flag=" + flag;
	aUrl += "&id=" + id;
	loadDesc(aUrl);
}


function loadDesc(url, updown) {
	if($.trim(grid) != "" && $.trim(grid.p) != "") {
		if(!url) {
            url = "";
		} else {
			updown = "middle";
		}
		if(!updown) {
			updown = "down";
		}
		grid.grid.resizeGridUpDown(updown);
	}
	$('#summary').attr("src", url);
}
