function escapeHTMLToString(str) {
	if (!str) {
		return "";
	}

	// str = str.replace("&","&amp;");
	str = str.replace("<", "&lt;");
	str = str.replace(">", "&gt;");
	str = str.replace("<br>", "");
	return str;
}

// 检查输入格式长度方法，因formValidate的检查未生效，单独做此方法
function checkMaxLength(element) {
	var value = element.value;
	if (!value) {
		return true;
	}

	var inputName = element.getAttribute("inputName");
	var maxLength = element.getAttribute("maxSize");
	if (maxLength && value.length > maxLength) {
		writeValidateInfo(element, v3x.getMessage("V3XLang.formValidate_maxLength", inputName, maxLength, value.length));
		return false;
	}
	return true;
}

// 检查特殊字符 |
function checkSpecialChar(obj) {
	if (obj) {
		if (/[\\|'"@#￥%]/.test(obj.value)) {// 不校验 / 字符
			alert(_("edocLang.edoc_mark_isnotwellformated"));
			return false;
		}
	}
	return true;
}

function selectAllValues(allButton, targetName) {
	var objcts = document.getElementsByName(targetName);
	if (objcts != null) {
		for (var i = 0; i < objcts.length; i++) {
			if (!objcts[i].disabled) {
				objcts[i].checked = allButton.checked;
			}
		}
	}
}

function showNextSpecialCondition(conditionObject) {
    var options = conditionObject.options;
    for (var i = 0; i < options.length; i++) {
        var d = document.getElementById(options[i].value + "Div");
        if (d) {
            d.style.display = "none";
        }
    }
    if(document.getElementById(conditionObject.value + "Div") == null) {
    	return;
    }
    document.getElementById(conditionObject.value + "Div").style.display = "block";
}

function checkTime(timeId, o, isAlert) {
	if($("#" + timeId) && $("#" + timeId).val()) {
		$("#" + timeId).val("");
	}
	var fromDate = $('#from_' + timeId).val();
	var toDate = $('#to_' + timeId).val();
	var date = fromDate + '#' + toDate;
	if(fromDate != "" && toDate != "" && fromDate > toDate) {
		if(isAlert != false) {
			$.alert($.i18n('collaboration.rule.date'));//开始时间不能早于结束时间
		}
     	return false;
 	}
	if(fromDate == null) {
		fromDate = '';
	}
	if(toDate == null) {
		toDate = '';
	}
	if(fromDate=='' && toDate==''){
    	date = '';
	}
	if(date != "") {
		o[timeId] = date;
		if($("#" + timeId) && $("#" + timeId).val()) {
			$("#" + timeId).val(date);
		}
	}
	return true;
}

//自定义查询中是否有自定义元素，如果有，也需要查询扩展表
function checkHasListElement(displayArr){
	for(var i=0;i<displayArr.length;i++){
		var ele = displayArr[i];
		if(ele=="list1" || ele=="list2" || ele=="list3" || ele=="list4" || ele=="list5" || ele=="list6" || ele=="list7" || ele=="list8" || ele=="list9" || ele=="list10" || ele=="list11" || ele=="list12" || ele=="list13" || ele=="list14" || ele=="list15" || ele=="list16" || ele=="list17" || ele=="list18" || ele=="list19" || ele=="list20"){
			return "true";
		}
	}
	return "false";
	
}

function getElementMap() {
	var elementMap = new Properties();
	elementMap.put("subject", "subject");//标题
	elementMap.put("doc_mark", "docMark");//公文文号
	elementMap.put("serial_no", "serialNo");//内部文号
	elementMap.put("create_person", "createPerson");//拟稿人/登记人
	elementMap.put("createdate", "createTime");//拟稿日期
	elementMap.put("send_unit", "sendUnit");//发文单位/来文单位(公文查询中，使用sendUnit有问题)
	elementMap.put("send_department", "sendDepartment");//发文部门/来文部门
	elementMap.put("issuer", "issuer");//签发人
	elementMap.put("signing_date", "signingDate");//签发日期
	elementMap.put("copies", "copies");
	elementMap.put("send_to", "sendTo");//主送单位
	elementMap.put("copy_to", "copyTo");//抄送单位
	elementMap.put("report_to", "reportTo");//抄报单位
	elementMap.put("print_unit", "printUnit");//印发单位
	elementMap.put("printer", "printer");//打印人
	elementMap.put("phone", "phone");//联系电话
	elementMap.put("auditor", "auditor");//审批人
	elementMap.put("review", "review");//复核人
	elementMap.put("undertaker", "undertaker");//承办人
	elementMap.put("undertakenoffice", "undertakenoffice");//承办机构
	elementMap.put("receive_unit", "receiveUnit");//接收单位
	elementMap.put("packdate", "packTime");//分送日期
	elementMap.put("receipt_date", "receiptDate");//签收日期
	elementMap.put("sign_person", "signPerson");//签收人
	elementMap.put("sign_mark", "signMark");//签收编号
	elementMap.put("registration_date", "registrationDate");//登记日期 
	elementMap.put("doc_type", "docType");//公文种类
	elementMap.put("send_type", "sendType");//行文类型
	elementMap.put("unit_level", "unitLevel");//公文级别
	elementMap.put("secret_level", "secretLevel");//密级
	elementMap.put("urgent_level", "urgentLevel");//紧急程度
	elementMap.put("keep_period", "keepPeriodTxt");//保密期限
	elementMap.put("hasArchive", "hasArchive");//保密期限
	elementMap.put("archiveName", "archiveName");//保密期限
	
	elementMap.put("pishiName", "leaderCommondNo");
	elementMap.put("currentNodesInfo", "currentNodesInfo");
	elementMap.put("summaryTransferStatusName", "summaryTransferStatusName");
	//自定义元素
	elementMap.put("string1", "string1");
	elementMap.put("string2", "string2");
	elementMap.put("string3", "string3");
	elementMap.put("string4", "string4");
	elementMap.put("string5", "string5");
	elementMap.put("string6", "string6");
	elementMap.put("string7", "string7");
	elementMap.put("string8", "string8");
	elementMap.put("string9", "string9");
	elementMap.put("string10", "string10");
	elementMap.put("string11", "string11");
	elementMap.put("string12", "string12");
	elementMap.put("string13", "string13");
	elementMap.put("string14", "string14");
	elementMap.put("string15", "string15");
	elementMap.put("string16", "string16");
	elementMap.put("string17", "string17");
	elementMap.put("string18", "string18");
	elementMap.put("string19", "string19");
	elementMap.put("string20", "string20");
	elementMap.put("string21", "string21");
	elementMap.put("string22", "string22");
	elementMap.put("string23", "string23");
	elementMap.put("string24", "string24");
	elementMap.put("string25", "string25");
	elementMap.put("string26", "string26");
	elementMap.put("string27", "string27");
	elementMap.put("string28", "string28");
	elementMap.put("string29", "string29");
	elementMap.put("string30", "string30");
	elementMap.put("integer1", "integer1");
	elementMap.put("integer2", "integer2");
	elementMap.put("integer3", "integer3");
	elementMap.put("integer4", "integer4");
	elementMap.put("integer5", "integer5");
	elementMap.put("integer6", "integer6");
	elementMap.put("integer7", "integer7");
	elementMap.put("integer8", "integer8");
	elementMap.put("integer9", "integer9");
	elementMap.put("integer10", "integer10");
	elementMap.put("integer11", "integer11");
	elementMap.put("integer12", "integer12");
	elementMap.put("integer13", "integer13");
	elementMap.put("integer14", "integer14");
	elementMap.put("integer15", "integer15");
	elementMap.put("integer16", "integer16");
	elementMap.put("integer17", "integer17");
	elementMap.put("integer18", "integer18");
	elementMap.put("integer19", "integer19");
	elementMap.put("integer20", "integer20");
	elementMap.put("decimal1", "decimal1");
	elementMap.put("decimal2", "decimal2");
	elementMap.put("decimal3", "decimal3");
	elementMap.put("decimal4", "decimal4");
	elementMap.put("decimal5", "decimal5");
	elementMap.put("decimal6", "decimal6");
	elementMap.put("decimal7", "decimal7");
	elementMap.put("decimal8", "decimal8");
	elementMap.put("decimal9", "decimal9");
	elementMap.put("decimal10", "decimal10");
	elementMap.put("decimal11", "decimal11");
	elementMap.put("decimal12", "decimal12");
	elementMap.put("decimal13", "decimal13");
	elementMap.put("decimal14", "decimal14");
	elementMap.put("decimal15", "decimal15");
	elementMap.put("decimal16", "decimal16");
	elementMap.put("decimal17", "decimal17");
	elementMap.put("decimal18", "decimal18");
	elementMap.put("decimal19", "decimal19");
	elementMap.put("decimal20", "decimal20");
	elementMap.put("date1", "date1");
	elementMap.put("date2", "date2");
	elementMap.put("date3", "date3");
	elementMap.put("date4", "date4");
	elementMap.put("date5", "date5");
	elementMap.put("date6", "date6");
	elementMap.put("date7", "date7");
	elementMap.put("date8", "date8");
	elementMap.put("date9", "date9");
	elementMap.put("date10", "date10");
	elementMap.put("date11", "date11");
	elementMap.put("date12", "date12");
	elementMap.put("date13", "date13");
	elementMap.put("date14", "date14");
	elementMap.put("date15", "date15");
	elementMap.put("date16", "date16");
	elementMap.put("date17", "date17");
	elementMap.put("date18", "date18");
	elementMap.put("date19", "date19");
	elementMap.put("date20", "date20");
	elementMap.put("list1", "list1");
	elementMap.put("list2", "list2");
	elementMap.put("list3", "list3");
	elementMap.put("list4", "list4");
	elementMap.put("list5", "list5");
	elementMap.put("list6", "list6");
	elementMap.put("list7", "list7");
	elementMap.put("list8", "list8");
	elementMap.put("list9", "list9");
	elementMap.put("list10", "list10");
	elementMap.put("list11", "list11");
	elementMap.put("list12", "list12");
	elementMap.put("list13", "list13");
	elementMap.put("list14", "list14");
	elementMap.put("list15", "list15");
	elementMap.put("list16", "list16");
	elementMap.put("list17", "list17");
	elementMap.put("list18", "list18");
	elementMap.put("list19", "list19");
	elementMap.put("list20", "list20");
	elementMap.put("text1", "text1");
	elementMap.put("text2", "text2");
	elementMap.put("text3", "text3");
	elementMap.put("text4", "text4");
	elementMap.put("text5", "text5");
	elementMap.put("text6", "text6");
	elementMap.put("text7", "text7");
	elementMap.put("text8", "text8");
	elementMap.put("text9", "text9");
	elementMap.put("text10", "text10");
	elementMap.put("text11", "text11");
	elementMap.put("text12", "text12");
	elementMap.put("text13", "text13");
	elementMap.put("text14", "text14");
	elementMap.put("text15", "text15");
	elementMap.put("text16", "text16");
	elementMap.put("text17", "text17");
	elementMap.put("text18", "text18");
	elementMap.put("text19", "text19");
	elementMap.put("text20", "text20");
	return elementMap;
}

function isMSIE() {
	var browser=navigator.appName
	var b_version=navigator.appVersion
	var version=b_version.split(";");
	try{
		var trim_Version=version[1].replace(/[ ]/g,"");
		if(browser=="Microsoft Internet Explorer"){
			return true;
		}
		if (!!window.ActiveXObject || "ActiveXObject" in window){
			return true;
		}
	}catch(e){}
	return false;
}


function isMSIE8() {
	var browser=navigator.appName
	var b_version=navigator.appVersion
	var version=b_version.split(";");
	var trim_Version=version[1].replace(/[ ]/g,"");
	if(browser=="Microsoft Internet Explorer" && trim_Version=="MSIE8.0"){
		return true;
	}
	return false;
}
/**
 * 获取文单iframe
 * @returns
 */
function getFormZwIframe() {
	var formZwIframe;
	try {
		formZwIframe = $(window.frames["govDocZwIframe"].document);//拟文界面
	} catch(e) {
		try {
			formZwIframe = $(window.frames["componentDiv"].window.frames["zwIframe"].document);//处理界面
		} catch(e2) {
			formZwIframe = $(document);
		}
	}
	return formZwIframe;
}
/**
 * 验证Offic是否加载完成
 * @param callback
 */
var checkOfficeComplete_n = 0;
function checkOfficeComplete(callback) {
	try {
		if(!OfficeAPI.hasLoadOfficeFrameComplete()) {
			if(checkOfficeComplete_n <= 15) {
				setTimeout(function() {
					checkOfficeComplete(callback);
				}, 500);
				checkOfficeComplete_n++;
				return;
			}
		} else {
			OfficeAPI.checkOpenState();	
		}
	} catch(e) {
		if(checkOfficeComplete_n <= 15) {
			setTimeout(function() {
				checkOfficeComplete(callback);
			}, 500);
			checkOfficeComplete_n++;
			return;
		}
	}
	//说明加载成功
	checkOfficeComplete_n = 0;
	if(callback) {
		callback();
	}
}
/**
 * 验证Pdf是否加载完成
 * @param iframe
 * @param callback
 */
var checkPdfComplete_n = 0;
function checkPdfComplete(checkFrame, callback) {
	try {
		if ((!checkFrame || checkFrame == null) || checkFrame.document.readyState != "complete") {
			setTimeout(function() {
				checkPdfComplete(checkFrame, callback);
			}, 300);
			return;
		}
		var isOpen = checkFrame.checkPDFOpenState();
		if (isOpen) {
			if (callback) {
				callback();
				return;
			}
		} else {
			if (checkPdfComplete_n <= 15) {
				setTimeout(function() {
					checkPdfComplete(checkFrame, callback);
				}, 500);
				checkPdfComplete_n++;
				return;
			}
		}
	} catch(e) {
		if(checkPdfComplete_n <= 15) {
			setTimeout(function() {
				checkPdfComplete(checkFrame, callback);
			}, 500);
			checkPdfComplete_n++;
			return;
		}
	}
}
/**
 * 验证页面是否加载完成
 * @param checkFrame
 * @param callback
 */
function checkDocumentComplete(checkFrame, callback) {
	try {
		if((!checkFrame || checkFrame==null) || checkFrame.document.readyState != "complete") {
			setTimeout(function() {
				checkDocumentComplete(checkFrame, callback);
			}, 300);
			return;
		}
	} catch(e) {
		setTimeout(function() {
			checkDocumentComplete(checkFrame, callback);
		}, 300);
		return;
	}
	if(callback) {
		callback();
	}
}
/**
 * 验证页面是否加载完成
 * @param checkFrame
 * @param callback
 */
function checkDocumentCompleteByVar(checkFrame, callback) {
	try {
		if((!checkFrame || checkFrame==null) || !checkFrame.hasLoadCompeleted) {
			setTimeout(function() {
				checkDocumentComplete(checkFrame, callback);
			}, 300);
			return;
		}
	} catch(e) {
		setTimeout(function() {
			checkDocumentComplete(checkFrame, callback);
		}, 300);
		return;
	}
	if(callback) {
		callback();
	}
}
function checkDocTemplateExist(isFromAdmin, orgAccountId, templateType, bodyType) {
	var result = false;
	var url = _ctxPath+"/govdoc/doctemplate.do?method=checkDocTemplateExist&isFromAdmin="+ isFromAdmin + "&orgAccountId=" + orgAccountId + "&templateType="+templateType + "&bodyType="+bodyType;
	$.ajax({
		async:false,
		url:url,
		dataType:"text",
		success:function(data) {
			if("true" == data) {
				result = true;
			}
		}
	});
	return result;
}	

function isOfficeContentType(bodyType) {
	if(bodyType == '41' || bodyType =="42" || bodyType=='43' || bodyType =='44' || bodyType =='45'){
		return true;
	}
	return false;
}

function convertBodyTypeByTextType(textType) {
	var bodyType;
	if (textType == 'officeword') {
		bodyType = "OfficeWord";
	} else if (textType == 'officewps' || textType == 'wpsword') {
		bodyType = "WpsWord";
	}
	return bodyType;
}

function convertSuffixByBodyType(bodyType) {
	var suffix;
	if (bodyType == 'OfficeWord') {
		suffix = "doc";
	} else if (bodyType == 'OfficeExcel') {
		suffix = "xls";
	} else if (bodyType == 'WpsWord') {
		suffix = "wps";
	} else if (bodyType == 'WpsExcel') {
		suffix = "et";
	} else if (bodyType == 'Pdf') {
		suffix = "pdf";
	} else if (bodyType == 'Ofd') {
		suffix = "ofd";
	}
	return suffix;
}

function convertContentType_bySuffix(suffix) {
	var sv;
	if (suffix == 'doc' || suffix == 'docx') {
		sv = "OfficeWord";
	} else if (suffix == 'xls' || suffix == 'xlsx') {
		sv = "OfficeExcel";
	} else if (suffix == 'wps') {
		sv = "WpsWord";
	} else if (suffix == 'et') {
		sv = "WpsExcel";
	} else if (suffix == 'pdf') {
		sv = "Pdf";
	} else if (suffix == 'ofd') {
		sv = "Ofd";
	}
	return sv;
}

function convertContentType_valueToString(bodyType) {
	var sv;
	if (bodyType == "10") {
		sv = "HTML";
	} else if (bodyType == "41") {
		sv = "OfficeWord";
	} else if (bodyType == "42") {
		sv = "OfficeExcel";
	} else if (bodyType == "43") {
		sv = "WpsWord";
	} else if (bodyType == "44") {
		sv = "WpsExcel";
	} else if (bodyType == "45") {
		sv = "Pdf";
	} else if (bodyType == "46") {
		sv = "Ofd";
	} else {
		return bodyType;
	}
	return sv;
}

function convertContentType_valueToText(bodyType) {
	var sv;
	if (bodyType == "10") {
		sv = "标准正文";
	} else if (bodyType == "41") {
		sv = "Word正文";
	} else if (bodyType == "42") {
		sv = "Excel正文";
	} else if (bodyType == "43") {
		sv = "Wps文字";
	} else if (bodyType == "44") {
		sv = "Wps表格";
	} else if (bodyType == "45") {
		sv = "Pdf正文";
	} else if (bodyType == "46") {
		sv = "Ofd正文";
	} else {
		return bodyType;
	}
	return sv;
}

function convertContentType_StringToValue(bodyType) {
	var sv;
	if (bodyType == "HTML") {
		sv = "10";
	} else if (bodyType == "OfficeWord") {
		if(getCurrentOcx() == "WPS"){
			sv = "43";
		}else{
			sv = "41";
		}
	} else if (bodyType == "OfficeExcel") {
		if(getCurrentOcx() == "WPS"){
			sv = "44";
		}else{
			sv = "42";
		}
	} else if (bodyType == "WpsWord") {
		sv = "43";
	} else if (bodyType == "WpsExcel") {
		sv = "44";
	} else if (bodyType == "Pdf") {
		if(v3x.isCurrentSysLinux()){
			sv = "46";
		}else{
			sv = "45";
		}
	} else if (bodyType == "Ofd") {
		sv = "46";
	} else {
		return bodyType;
	}
	return sv;
}

function isInArray(array, item) {
	if(array && array.length > 0) {
		for(var i=0; i<array.length; i++) {
			if(array[i] == item) {
				return true;
			}
		}
	}
	return false;
}

function checkHasPlugin(plugin) {
	var hasPlugin = $.ctx.isOfficeEnabled(plugin);
	if (hasPlugin === true || hasPlugin === "true") {
		return true;
	}
	return false;
}

function isOfficeEnabled(plugin,isIgnore) {
	var hasPlugin = $.ctx.isOfficeEnabled(plugin,isIgnore);
	if (hasPlugin === true || hasPlugin === "true") {
		return true;
	}
	return false;
}

//检查模板是否可用
function checkTemplateCanUse(templateId) {
	var ajaxmanager = new govdocAjaxManager();
	var strFlag = ajaxmanager.checkTemplateCanUse(templateId);
	if(strFlag.flag =='cannot') {
		return false;
	} else {
		return true;
	}
}

function isIframeLoad(iframeId) {
	if($("#" + iframeId).contents().find("body").html() != "") {
		return true;
	}
	return !($("#" + iframeId).attr("src") == "about:blank" || $("#" + iframeId).attr("src")=="" || $("#" + iframeId).contents().find("body").html()=="");
}


/**
 * 清除初始化的定时事件
 * @param intervalObj 定时对象
 */
function clearGovInterval(intervalObj){
	if(intervalObj){
		window.clearInterval(intervalObj);
		intervalObj=null;
	}
}

/**
 * 初始化转发的标题(例如：会议纪要转公文后的标题)
 * @param subject
 * 
 */
function initTransSubject(subject){
	if("undefined" == typeof subject || subject == "" || subject == null){
		clearGovInterval(transSubjectInterval);
		return;
	}
	var zw = window.frames["govDocZwIframe"].document; 
	if("undefined"== typeof zw  || zw==null){
		clearGovInterval(transSubjectInterval);
		return;
	}
	if(zw.readyState != 'complete'){
		return false;
	}else{
		clearGovInterval(transSubjectInterval);
	}
	var subjectElementList = $(zw).find("[mappingField='subject']")
	var subjectElement = subjectElementList[0];
	if("undefined" == typeof subjectElement || subjectElement==null){
		clearGovInterval(transSubjectInterval);
		return;
	}
	subjectElement.value = subject;
	
}

/**
 * AJax记录流程日志
 */
 function recordChangeWord(affair_IdValue ,summary_IdValue ,ajaxStr,userId) {
 	if(null == affair_IdValue || "" == affair_IdValue){
 		var url = window.location.search;
 		affair_IdValue = GetQueryString(url,"affairId");
 	}
 	if(null == summary_IdValue || "" == summary_IdValue){
 		var url = window.location.search;
 		var summaryId2 = GetQueryString(url,"summaryId");
 	  if(!summaryId2){
 		  summaryId2 = summaryId;
 	  }
 		summary_IdValue = summaryId2;
 	}
   if(affair_IdValue == "" && summary_IdValue == "" && ajaxStr == "")
     return ;
     try{
         if(affair_IdValue && summary_IdValue) {
         	var ajaxManager = new govdocAjaxManager();
             var params = new Object();
             params["affairId"] =  affair_IdValue;
             params["summaryId"] =  summary_IdValue;
             params["changeType"] =  ajaxStr;
             params["userId"] =  userId;
             ajaxManager.recoidChangeWord(params);
         }
     }catch(e){
     }
 }
 

 var add$OnBeforeUnloadEvent = function(callback) {
   var ua = navigator.userAgent;
   var isMSIE = (navigator.appName == "Microsoft Internet Explorer") || ua.indexOf('Trident') != -1;
   if (isMSIE) {
       document.body.onbeforeunload = function() {
           callback();
       };
   }
   else {
       if (navigator.userAgent.indexOf('Firefox') != -1) {
           window.onbeforeunload = function(e) {
               callback();
           }
       }
       else if (navigator.userAgent.indexOf('Safari') != -1) {
           window.addEventListener("beforeunload", callback, false);
       }
       else {
           window.addEventListener("beforeunload", callback, false);
       }
   }
};

var remove$OnBeforeUnloadEvent = function(callback) {
   var ua = navigator.userAgent;
   var isMSIE = (navigator.appName == "Microsoft Internet Explorer") || ua.indexOf('Trident') != -1;
   if (isMSIE) {
       document.body.onbeforeunload = null;
   }
   else {
       if (navigator.userAgent.indexOf('Firefox') != -1) {
           window.onbeforeunload = null
       }
       else if (navigator.userAgent.indexOf('Safari') != -1) {
           window.removeEventListener('beforeunload',callback,false);
       }
       else {
           window.removeEventListener('beforeunload',callback,false);
       }
   }
};

/*只有chrome49才屏蔽掉浏览器弹窗*/
function isChrome49(){
	try{
		var ua = navigator.userAgent;
		if(ua.indexOf('Chrome') != -1 && ua.match(/chrome\/[\d.]+/gi)[0].indexOf("Chrome/49") != -1){
			return true;
		}
	}catch(e){}
	return false;
}


function getDom(){
    if(xmlDoc == null){
        try{
            xmlDoc = new ActiveXObject( "SeeyonFileDownloadLib.SeeyonFileDownload");
            xmlDoc.AddUserParam(currentUserLocale, currentUserloginName , _sid , $.ctx.CurrentUser.id );
        }catch(ex1){
         
        }
    }
    return xmlDoc;
}

function isNewLayout() {
	if(typeof(newGovdocView)!='undefined' && newGovdocView != "0") {
		return true;
	} else {
		return false;
	}
}
function getSessionId(){
	var requestCaller = new XMLHttpRequestCaller(this, "ajaxHandWriteManager", "ajaxGetSession",false);
	var ds = requestCaller.serviceRequest();
	return $.parseJSON(ds).JSESSIONID;
}
/**
 * 验证密级
 * @returns
 */
function checkWfSecretLevel(checkAction,extData) {
	if(hasSecretPlugin == "false"){
		return true;
	}
	var secretLevel = $("#secretLevel").val();
	var templateProcessId = "";
	var processId = "";
	var processInfo = "";
	var process_message_data = "";
	if(checkAction == "send" && systemTemplate == true) {
		templateProcessId = workflowId;
		if (customDealWith != "true") {
			processInfo = $('#process_info').tokenInput("get");
			if (processInfo != null && processInfo != ""
					&& processInfo != "undefined") {
				processInfo = getTrueValues(processInfo);
			}
		}
	} else if(checkAction == "deal") {
		process_message_data = $("#process_message_data").val();
		processId = $("#processId").val();
	}
	var processXml = $("#process_xml").val();
	var zdgzry = $("#zdgzry").val();
	var supervisorIds = $("#supervisorIds").val();
	var result = callBackendMethod("secretAjaxManager", "checkWfSecretLevel", secretLevel, templateProcessId, processId, processXml, processInfo, process_message_data, zdgzry, supervisorIds,extData);
	if(result && result.res == "false") {
		$.alert(result.msg);
		for(var key in opinionArrayObj){
			opinionArrayObj[key].nodeId = null;
		}
		return false;
	}	
	return true;
}