var ie8VersionFlag =false;

/**
 * 页面加载初始化
 */
$(document).ready(function() {
	//工具栏
    ie8VersionFlag = $.browser.version =='8.0';
	loadUE();
	loadSearch();
	loadData();
	//loadEvent();
});

/**
 * 加载页面事件
 */
function loadEvent() {
	$("#list4Quote").find("input[type='checkbox']").each(function() {
		$(this).unbind("click").bind("click", function() {
			selectGovdocInfo(this);
		});
	});
}

/**
 * 加载列表小查询
 */
function loadSearch() {
	var conditionArray = new Array();
	//标题
	conditionArray.push({
        id: 'subject',
        name: 'subject',
        type: 'input',
        text: $.i18n("cannel.display.column.subject.label"),
        validate:false,
        value: 'subject',
        maxLength:100
    });
	conditionArray.push({
        id: 'docMark',
        name: 'docMark',
        type: 'input',
        text: $.i18n("govdoc.docMark.label"),//公文文号
        value: 'docMark',
        maxLength:100
    });
	conditionArray.push({
        id: 'serialNo',
        name: 'serialNo',
        type: 'input',
        text: $.i18n("govdoc.serialNo.label"),//内部文号
        value: 'serialNo',
        maxLength:100
    });
	//发起人
	conditionArray.push({
        id: 'startUserName',
        name: 'startUserName',
        type: 'input',
        text: $.i18n("cannel.display.column.sendUser.label"),
        validate:false,
        value: 'startUserName'
    });
	//发起时间
	conditionArray.push({
        id: 'startTime',
        name: 'startTime',
        type: 'datemulti',
        text: $.i18n("common.date.sendtime.label"),
        value: 'startTime',
        ifFormat:'%Y-%m-%d',
        dateTime: true
    });
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 50,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	o.govdocType = $("input[name='govdocType']:checked").val();
	o.listType = listType;

	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose == 'docMark') {// 公文文号
		o.docMark = $('#docMark').val();
	} else if (choose == 'serialNo') {// 内部文号
		o.serialNo = $('#serialNo').val();
	} else if (choose === 'subject') {// 标题
		o.subject = $('#subject').val();
	} else if (choose === 'startUserName') {// 发起人
		o.startUserName = $('#startUserName').val();
	} else if (choose === 'startTime') {// 发起时间
		if(!checkTime("startTime", o, false)) {//发起日期
	    	return;
	    }
	}	
	o.condition = "choose";
	return o;
}

/**
 * 列表数据加载
 */
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : '',
		name : 'affairId',
		width : '4%',
		isToggleHideShow : false
	});
	//状态
	colModels.push({
    	 display: $.i18n("common.coll.state.label"),
         name: 'affairState',
         sortable : true,
         width: '9%'
    });
	//标题
	colModels.push({
    	display: $.i18n("common.subject.label"),
        name: 'subject',
        sortable : true,
        width: '35%'
    });
	//公文文号
	colModels.push({
    	display: $.i18n("govdoc.docMark.label"),
        name: 'docMark',
        sortable : true,
        width: '12%'
    });
	// 内部文号
	colModels.push({
    	display: $.i18n("govdoc.serialNo.label"),
        name: 'serialNo',
        sortable : true,
        width: '12%'
    });
	//发起人
	colModels.push({
    	display: $.i18n("cannel.display.column.sendUser.label"),
        name: 'startUserName',
        sortable : true,
        width: '9%'
    });
	//发起时间
	colModels.push({
    	display:  $.i18n("common.date.sendtime.label"),
        name: 'startTime',
        sortable : true,
        width: '15%'
    });
	grid = $('#list4Quote').ajaxgrid({
		colModel : colModels,
		render : rend,
		height : 200,
		showTableToggleBtn : true,
		parentId : $('.layout_center').eq(0).attr('id'),
		vChange : false,
		vChangeParam : {
			overflow : "hidden",
			autoResize : false
		},
		resizable: false,
		isHaveIframe : false,
		slideToggleBtn : false,
		managerName : "govdocListManager",
		managerMethod : "find4QuoteList"
	});
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#list4Quote").ajaxgridLoad(o);
   // loadEvent();
}

/**
 * 列表数据回填
 * @param txt
 * @param data
 * @param r
 * @param c
 * @param col
 * @returns
 */
function rend(txt, data, r, c, col) {
	if (null == txt) {// 修正 如果是未讀，那麼會顯示null字符串
		txt = "";
	}
	
	if(col.name === "affairId") {
		var mapOptions = parent.fileUploadAttachments.instanceKeys.instance;
        for(var k = 0; k <mapOptions.length; k++) {
            if (mapOptions[k] == data.affairId) {
                txt = "<input type='checkbox' checked='checked' id='boxId' name='"+escapeStringToHTMLForGov(data.subject,null,false,true)+"' onclick='selectGovdocInfo(this)' value='"+data.affairId+"' objectId='"+data.objectId+"' subObjectId='"+data.subObjectId+"' affairApp='"+data.affairApp+"' affairSubApp='"+data.affairSubApp+"' affairId='"+data.affairId+"' createDate='"+data.createTime+"'/>";
                return txt;
            }
        }
        txt = "<input type='checkbox' id='boxId' name='"+escapeStringToHTMLForGov(data.subject,null,false,true)+"' onclick='selectGovdocInfo(this)' value='"+data.affairId+"' objectId='"+data.objectId+"' subObjectId='"+data.subObjectId+"' affairApp='"+data.affairApp+"' affairSubApp='"+data.affairSubApp+"' affairId='"+data.affairId+"' createDate='"+data.createTime+"'/>";
 	} else if (col.name === "subject") {// 标题
		txt = getListSubjectTxt(txt, data, true, true, true, true, true, true, true, true, true);
	} else if (col.name === "affairState") {// 状态
		txt = getListAffairStateTxt(txt, data);
	} else if(col.name === "startUserName") {//发起人
		txt = getListRedColorTxt(txt, data);
	}
	
	return txt;
}

function selectGovdocInfo(obj) {
	if(obj.name == "") {
		$(obj).attr("name", $(obj).parents("tr").find("td[abbr='subject']").find("span[class='grid_black']").html());	
	}
	parent.quoteDocumentSelected(obj, obj.name, 'edoc', obj.value);
}

function deselectItem(affairId) {
    if(ie8VersionFlag) {
    	$(":checkbox[value='"+affairId+"']").attr("checked", false);
    } else {
        $("#boxId[value='"+affairId+"']").attr("checked", false);
    }
}   

// 双击事件
function dbclickRow(obj, rowIndex, colIndex) {
	var data = new Object();
	data.subject = $(obj).attr("subject");
	data.summaryId = $(obj).attr("summaryId");
	data.govdocType = $(obj).attr("govdocType");
	data.affairId = $(obj).attr("affairId");
	data.affairObjectId = $(obj).attr("affairObjectId");
	data.affairSubObjectId = $(obj).attr("affairSubObjectId");
	data.affairApp = $(obj).attr("affairApp");
	data.affairSubApp = $(obj).attr("affairSubApp");
	
	if (!isAffairValid(data.affairId)) {
		reloadListGrid();
		return;
	}
	
	var _url = getListClickUrl(data, "glwd");
	if(!_url) {
		return;
	}
	
	var _title = data.subject;
	openGovdocDialog(_url, escapeStringToHTML(_title));
	grid.grid.resizeGridUpDown('down');
}

function changeQuoteType(obj) {
    if(obj.checked){
        var o = new Object();
        o.listType = listType;
        o.govdocType = $(obj).val();
        if($.ctx.plugins.contains('secret')){
        	o.secretLevel=listSecretLevel;
        }
        searchByCondition(o);
    }
}

function loadPendingGrid() {
	var url = window.location.search;
	var o = new Object();
	setParamsToObject(o, url);
	$("#listPending").ajaxgridLoad(o);
}

/**
 * 将字符串转换成HTML代码
 */
function escapeStringToHTMLForGov(str, isEscapeSpace, isEscapeBr ,isReplaceBrToBlank){
	if(!str){
		return "";
	}

	str = str.replace(/&/g, "&amp;");
	str = str.replace(/</g, "&lt;");
	str = str.replace(/>/g, "&gt;");
	str = str.replace(/\r/g, "");
	if(typeof(isReplaceBrToBlank) == 'undefined' || (isReplaceBrToBlank == true || isReplaceBrToBlank == "true")){
		str = str.replace(/\n/g, " ");
	}
	if(typeof(isEscapeBr) == 'undefined' || (isEscapeBr == true || isEscapeBr == "true")){
	  str = str.replace(/\n/g, "<br/>");
	}
	str = str.replace(/\'/g, "&#039;");
	str = str.replace(/"/g, "&#034;");

	if(typeof(isEscapeSpace) != 'undefined' && (isEscapeSpace == true || isEscapeSpace == "true")){
		str = str.replace(/ /g, "&nbsp;");
	}

	return str;
}
