/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadToolbar();
	loadSearch();
	loadData();
});

/**
 * 加载页面按钮
 */
function loadToolbar() {
	var toolbarArray = new Array();
	// 归档
	if (isShowPigeonhole() && actionArchive) {
		toolbarArray.push({
			id : "pigeonhole",
			name : $.i18n('collaboration.toolbar.pigeonhole.label'),
			className : "ico16 filing_16",
			click : function() {
				doPigeonhole("govdocsent", grid, "listSent");
			}
		});
	}
	if ((isNotG6S || (!isNotG6S && govdocType != "1")) && actionCancel) {//非G6-S 或G6-S收文
		// 撤销流程
		toolbarArray.push({
			id : "cancelWorkFlow",
			name : $.i18n('common.repeal.workflow.label'),
			className : "ico16 revoked_process_16",
			click : doCancel
		});
	}
	if((govdocType.indexOf("2") > -1 || listType == 'listSentAllRoot') && actionTurnRecEdoc){
		//转办
		toolbarArray.push({
			id : "turnToRec",
			name : $.i18n('govdoc.button.turnToRec.label'),
			className : "ico16 forward_event_16",
			click : turnToRec
		});
	}
	//转公告
	if(actionTransmitBulletin){
		toolbarArray.push({
			id : "transmitBulletin",
			name : $.i18n('govdoc.button.transmitBulletin.label'),
			className : "ico16 transfer_bulletin_16",
			click : dealTransmitBulletinFunc
		});
	}
	// 删除
	toolbarArray.push({
		id : "delete",
		name : $.i18n('collaboration.button.delete.label'),
		className : "ico16 del_16",
		click : function() {
			doDelete('sent', 'listSent','listSent');
		}
	});

    if(hasDumpData == "true"){
    	//当前数据
    	toolbarArray.push({
    		id: "currentData",
    		name: $.i18n('govdoc.button.currentData.label.js'),
    		className:"ico16 view_switch_16",
    		click:currentData
    	});
    	//转储数据
    	toolbarArray.push({
    		id: "dumpData",
    		name: $.i18n('govdoc.button.dumpData.label.js'),
    		className:"ico16 view_switch_16",
    		click:dumpData
    	});
    }
	// toolbar扩展
	for (var i = 0; i < addinMenus.length; i++) {
		toolbarArray.push(addinMenus[i]);
	}
	// 工具栏
	toolbar = $("#toolbars").toolbar({
		toolbar : toolbarArray
	});

    if(hasDumpData == "true"){
	    //设置按钮样式
	    document.getElementById("currentData_a").style.display = "none";
    }
}

/**
 * 加载列表小查询
 */
function loadSearch() {
	var conditionArray = new Array();
	// 标题
	conditionArray.push({
		id : 'subject',
		name : 'subject',
		type : 'input',
		text : $.i18n("cannel.display.column.subject.label"),
		value : 'subject',
		maxLength : 100
	});
	// 公文文号
	conditionArray.push({
		id : 'docMark',
		name : 'docMark',
		type : 'input',
		text : $.i18n("govdoc.docMark.label"),
		value : 'docMark',
		maxLength : 100
	});
	// 内部文号
	conditionArray.push({
		id : 'serialNo',
		name : 'serialNo',
		type : 'input',
		text : $.i18n("govdoc.serialNo.label"),
		value : 'serialNo',
		maxLength : 100
	});
	// 发起时间
	conditionArray.push({
		id : 'startTime',
		name : 'startTime',
		type : 'datemulti',
		text : $.i18n("common.date.sendtime.label"),
		value : 'startTime',
		ifFormat : '%Y-%m-%d',
		dateTime : false
	});
	// 密级
	conditionArray.push({
		id : 'secretLevel',
		name : 'secretLevel',
		type : 'select',
		text : $.i18n("govdoc.secretLevel.label"),
		value : 'secretLevel',
		items : secretLevelOptions
	});
	// 紧急程度
	conditionArray.push({
		id : 'urgentLevel',
		name : 'urgentLevel',
		type : 'select',
		text : $.i18n("govdoc.urgentLevel.label"),
		value : 'urgentLevel',
		items : urgentLevelOptions
	});
	// 流程期限
	conditionArray.push({
		id : 'summaryDeadLine',
		name : 'summaryDeadLine',
		type : 'datemulti',
		text :  $.i18n("collaboration.process.cycle.label"),
		value : 'summaryDeadLine',
		ifFormat:'%Y-%m-%d',
	    dateTime:false
	});
	
	// 流程状态
	var flowStateItems = new Array();
	flowStateItems.push({text : $.i18n("collaboration.unend"), value : '0' });// 未结束
	flowStateItems.push({text : $.i18n("collaboration.ended"), value : '3' });// 已结束
	flowStateItems.push({text : $.i18n("collaboration.eventsource.category.terminate"), value : '1' });// 已终止
	conditionArray.push({// 流程状态
		id : 'flowState',
		name : 'flowState',
		type : 'select',
		text : $.i18n("common.flow.state.label"),
		value : 'flowState',
		items : flowStateItems
	});
	
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 10,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	o.govdocType = govdocType;
	o.listType = listType;
	o.templateIds = templateIds;
	
	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose === 'subject') {//标题
		o.subject = $('#subject').val();
	} else if (choose == 'docMark') {// 公文文号
		o.docMark = $('#docMark').val();
	} else if (choose == 'serialNo') {// 内部文号
		o.serialNo = $('#serialNo').val();
	} else if (choose == 'secretLevel') {// 密级
		o.secretLevel = $('#secretLevel').val();
	} else if (choose == 'urgentLevel') {// 紧急程度
		o.urgentLevel = $('#urgentLevel').val();
	} else if (choose === 'startTime') {//发起时间
		if(!checkTime("startTime", o, false)) {//发起日期
	    	return;
	    }
	} else if (choose == 'summaryDeadLine') { // 流程期限
		if(!checkTime("summaryDeadLine", o, false)) {//处理时限
	    	return;
	    }
	} else if (choose == 'flowState') {	// 流程状态
		o.flowState = $('#flowState').val();
	}
	o.condition = "choose";
    o.dumpData = dataType;
	return o;
}

/**
 * 列表数据加载
 */
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : 'id',
		name : 'affairId',
		width : '4%',
		type : 'checkbox',
		isToggleHideShow : false
	});
	// 分类
	if(govdocType==""){
		colModels.push({
			display : $.i18n("govdoc.classified.label"),
			name : 'govdocType',
			sortable : true,
			width : '5%'
		});
	}
	// 标题
	colModels.push({
		display : $.i18n("common.subject.label"),
		name : 'subject',
		sortable : true,
		width : '30%'
	});
	// 公文文号
	colModels.push({
		display : $.i18n("govdoc.docMark.label"),
		name : 'docMark',
		sortable : true,
		width : '9%'
	});
	// 内部文号
	colModels.push({
		display : $.i18n("govdoc.serialNo.label"),
		name : 'serialNo',
		sortable : true,
		width : '9%'
	});
	// 紧急程度
	colModels.push({
		display : $.i18n("govdoc.urgentLevel.label"),
		name : 'urgentLevel',
		sortable : true,
		width : '9%'
	});
	// 密级
	colModels.push({
		display : $.i18n("govdoc.secretLevel.label"),
		name : 'secretLevel',
		sortable : true,
		width : '9%'
	});
	// 当前待办人
	colModels.push({
		display : $.i18n("govdoc.currentNodesInfo.label"),
		name : 'currentNodesInfo',
		sortable : true,
		width : '9%'
	});
	// 是否归档
	colModels.push({
		display : $.i18n("govdoc.canArchive.label"),
		name : 'hasArchive',
		sortable : true,
		width : '9%'
	});
	if(govdocType == "" || govdocType == "1") {
		//分送状态
		colModels.push({
	    	display : $.i18n("govdoc.DistributeState.label"),
	    	name: 'govdocExchangeMainId',
	    	width: '9%'
	    });
	}
	// 流程期限
	colModels.push({
		display : $.i18n("collaboration.process.cycle.label"),
		name : 'summaryDeadLineName',
		sortable : true,
		width : '9%'
	});
	// 跟踪状态
	colModels.push({
		display : $.i18n("collaboration.isTrack.label"),
		name : 'affairTrack',
		sortable : true,
		width : '12%'
	});
	// 发起时间
	colModels.push({
		display : $.i18n("common.date.sendtime.label"),
		name : 'startTime',
		sortable : true,
		width : '9%'
	});
	// 流程日志
	colModels.push({
		display : $.i18n("processLog.list.title.label"),
		name : 'processId',
		width : '9%'
	});

	grid = $('#listSent').ajaxgrid({
		colModel : colModels,
		click : dbclickRow,
		render : rend,
		height : 200,
		showTableToggleBtn : true,
		parentId : $('.layout_center').eq(0).attr('id'),
		vChange : false,
		vChangeParam : {
			overflow : "hidden",
			autoResize : false
		},
		isHaveIframe : false,
		slideToggleBtn : false,
		resizable: false,
		managerName : "govdocListManager",
		managerMethod : "findSentList"
	});
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    o.dumpData = dataType;
    $("#listSent").ajaxgridLoad(o);
}

/**
 * 列表数据回填
 * @param txt
 * @param data
 * @param r
 * @param c
 * @param col
 * @returns
 */
function rend(txt, data, r, c, col) {
	if (null == txt) {// 修正 如果是未讀，那麼會顯示null字符串
		txt = "";
	}
	if (col.name === "govdocType") {//分类
		return getListGovdocTypeName(data.govdocType, data.affairSubApp);
	} else if (col.name === "subject") {//标题
		return getListSubjectTxt(txt, data, true, false, true, true, true, true, false, true);
	} else if (col.name === "currentNodesInfo") {//当前待办人
		return getCurrentNodesInfoTxt(txt, data);
	} else if (col.name === "hasArchive") {// 是否归档
		if (txt == true) {
			txt = $.i18n('govdoc.canArchive.label.yes');
		} else {
			txt = $.i18n('govdoc.canArchive.label.no');
		}
		return txt;
	} else if (col.name === "govdocExchangeMainId") {//分送状态
		return getListDistributeStateTxt(data);
	} else if (col.name === "summaryDeadLineName") {//流程期限
		return getListSummaryIsCoverTimeTxt(txt, data);
	} else if (col.name === "affairTrack") {//跟踪状态
		return getListTrackTxt(txt, data, true);
	} else if (col.name === "processId") {//流程日志
		return getListProcessIdTxt(data);
	}
	return txt;
}

// 双击事件
function dbclickRow(data, rowIndex, colIndex) {
	if (colIndex == 11) {
		return;
	}
	
	if (!isAffairValid(data.affairId)) {
		reloadListGrid();
		return;
	}
	
	var _url = getListClickUrl(data, "listSent");
	if(!_url) {
		return;
	}

	var _title = data.subject;
	openGovdocDialog(_url, escapeStringToHTML(_title));
	grid.grid.resizeGridUpDown('down');
	
}
var dataType;//数据类型，0：当前数据；1：转储数据
//展示主库数据
function currentData(){
	//放开按钮
	toolbar.enabled("cancelWorkFlow");
	toolbar.enabled("turnToRec");
	toolbar.enabled("delete");
	toolbar.enabled("pigeonhole");
	toolbar.enabled("transmitBulletin");

	document.getElementById("currentData_a").style.display = "none";
	document.getElementById("dumpData_a").style.display = "";

	dataType = '0'; //当前数据
	$("#listSent").ajaxgridLoad(getConditionObj());
}
//展示转储数据
function dumpData(){
	//置灰按钮
	toolbar.disabled("cancelWorkFlow");
	toolbar.disabled("turnToRec");
	toolbar.disabled("delete");
	toolbar.disabled("pigeonhole");
	toolbar.disabled("transmitBulletin");

	document.getElementById("dumpData_a").style.display = "none";
	document.getElementById("currentData_a").style.display = "";

	dataType = '1'; //转储数据
	$("#listSent").ajaxgridLoad(getConditionObj());
}
