/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadToolbar();
	loadSearch();
	loadData();
});

/**
 * 加载页面按钮
 */
function loadToolbar() {
	var toolbarArray = new Array();
	// 编辑
	toolbarArray.push({
		id : "edit",
		name : $.i18n('collaboration.edit.label'),
		className : "ico16 editor_16",
		click : doEdit
	});
	// 删除
	toolbarArray.push({
		id : "delete",
		name : $.i18n('collaboration.button.delete.label'),
		className : "ico16 del_16",
		click : function() {
			doDelete('draft', 'listWaitSend','listWaitSend');
		}
	});
	if (govdocType.indexOf("2") > -1) {// 收文中待发(需要去掉待发公文-- xucb)
		toolbarArray.push({
			id : "takeDeal",
			name : $.i18n("govdoc.rollback.fenban"),
			className : "ico16 editor_16",
			click : doTakeDeal
		});
	}
	// toolbar扩展
	for ( var i = 0; i < addinMenus.length; i++) {
		toolbarArray.push(addinMenus[i]);
	}
	$("#toolbars").toolbar({
		toolbar : toolbarArray
	});
}

/**
 * 加载列表小查询
 */
function loadSearch() {
	var conditionArray = new Array();
	// 标题
	conditionArray.push({
		id : 'subject',
		name : 'subject',
		type : 'input',
		text : $.i18n("cannel.display.column.subject.label"),
		value : 'subject',
		maxLength : 100
	});
	// 公文文号
	conditionArray.push({
		id : 'docMark',
		name : 'docMark',
		type : 'input',
		text : $.i18n("govdoc.docMark.label"),
		value : 'docMark',
		maxLength : 100
	});
	// 内部文号
	conditionArray.push({
		id : 'serialNo',
		name : 'serialNo',
		type : 'input',
		text : $.i18n("govdoc.serialNo.label"),
		value : 'serialNo',
		maxLength : 100
	});
	// 紧急程度
	conditionArray.push({
		id : 'urgentLevel',
		name : 'urgentLevel',
		type : 'select',
		text : $.i18n("govdoc.urgentLevel.label"),
		value : 'urgentLevel',
		items : urgentLevelOptions
	});
	// 密级
	conditionArray.push({
		id : 'secretLevel',
		name : 'secretLevel',
		type : 'select',
		text : $.i18n("govdoc.secretLevel.label"),
		value : 'secretLevel',
		items : secretLevelOptions
	});
	// 发起时间(这里指的是创建时间)
	conditionArray.push({
		id : 'createTime',
		name : 'createTime',
		type : 'datemulti',
		text : $.i18n("common.date.sendtime.label"),
		value : 'createTime',
		ifFormat : '%Y-%m-%d',
		dateTime : false
	});
	// 状态
	var draftStateItems = new Array();
	draftStateItems.push({
		text : $.i18n("collaboration.substate.3.label"),// 撤销
		value : '3'
	});
	draftStateItems.push({
		text : $.i18n("collaboration.substate.1.label"),// 草稿
		value : '1'
	});
	draftStateItems.push({
		text : $.i18n("collaboration.substate.new.2.label"),// 被回退
		value : '2'
	});
	conditionArray.push({
		id : "draftState",
		name : 'draftState',
		type : 'select',
		text : $.i18n('common.coll.state.label'),
		value : 'draftState',
		items : draftStateItems
	});
	searchobj = $.searchCondition({
		top : topSearchSize,
		right : 10,
		searchHandler : function() {
			var o = getConditionObj();
			if(o) {
				searchByCondition(o);	
			}
		},
		conditions : conditionArray
	});
}

function getConditionObj() {
	var o = new Object();
	o.govdocType = govdocType;
	o.listType = listType;
	o.templateIds = templateIds;

	var choose = $('#' + searchobj.p.id).find("option:selected").val();
	if (choose === 'subject') {// 标题
		o.subject = $('#subject').val();
	} else if (choose == 'docMark') {// 公文文号
		o.docMark = $('#docMark').val();
	} else if (choose == 'serialNo') { // 内部文号
		o.serialNo = $('#serialNo').val();
	} else if (choose == 'urgentLevel') { // 紧急程度
		o.urgentLevel = $('#urgentLevel').val();
	} else if (choose == 'secretLevel') {// 密级
		o.secretLevel = $('#secretLevel').val();
	} else if (choose === 'createTime') {// 发起时间
		if(!checkTime("createTime", o, false)) {//发起日期
	    	return;
	    }
	} else if (choose === 'draftState') {// 状态
		o.draftState = $('#draftState').val();
	}
	o.condition = "choose";
	return o;
}

/**
 * 列表数据加载
 */
function loadData() {
	var colModels = new Array();
	colModels.push({
		display : 'affairId',
		name : 'affairId',
		width : '5%',
		type : 'checkbox',
		isToggleHideShow : false
	});
	if(govdocType==""){
		// 分类
		colModels.push({
			display : $.i18n("govdoc.classified.label"),
			name : 'govdocType',
			sortable : true,
			width : '5%'
		});
	}
	
	// 标题
	colModels.push({
		display : $.i18n("common.subject.label"),
		name : 'subject',
		sortable : true,
		width : '30%'
	});
	// 公文文号
	colModels.push({
		display : $.i18n("govdoc.docMark.label"),
		name : 'docMark',
		sortable : true,
		width : '9%'
	});
	// 内部文号
	colModels.push({
		display : $.i18n("govdoc.serialNo.label"),
		name : 'serialNo',
		sortable : true,
		width : '9%'
	});
	// 紧急程度
	colModels.push({
		display : $.i18n("govdoc.urgentLevel.label"),
		name : 'urgentLevel',
		sortable : true,
		width : '9%'
	});
	// 密级
	colModels.push({
		display : $.i18n("govdoc.secretLevel.label"),
		name : 'secretLevel',
		sortable : true,
		width : '9%'
	});
	// 状态
	colModels.push({
		display : $.i18n("common.coll.state.label"),
		name : 'subState',
		sortable : true,
		width : '8%'
	});
	// 发起时间(这里指创建时间)
	colModels.push({
		display : $.i18n("common.date.sendtime.label"),
		name : 'createTime',
		sortable : true,
		width : '10%'
	});
	// 流程期限
	colModels.push({
		display : $.i18n("collaboration.process.cycle.label"),
		name : 'summaryDeadLineName',
		sortable : true,
		width : '9%'
	});

	grid = $('#listWaitSend').ajaxgrid({
		colModel : colModels,
		click : dbclickRow,
		render : rend,
		height : 200,
		showTableToggleBtn : true,
		parentId : $('.layout_center').eq(0).attr('id'),
		vChange : false,
		vChangeParam : {
			overflow : "hidden",
			autoResize : false
		},
		resizable: false,
		isHaveIframe : false,
		slideToggleBtn : false,
		managerName : "govdocListManager",
		managerMethod : "findWaitSendList"
	});
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
	$("#listWaitSend").ajaxgridLoad(o);
}

/**
 * 列表数据回填
 * @param txt
 * @param data
 * @param r
 * @param c
 * @param col
 * @returns
 */
function rend(txt, data, r, c, col) {
	if (null == txt) {// 修正 如果是未讀，那麼會顯示null字符串
		txt = "";
	}
	if (col.name === "govdocType") {// 分类
		return getListGovdocTypeName(data.govdocType, data.affairSubApp);
	} else if (col.name === "subject") {//标题
		return getListSubjectTxt(txt, data, true, false, true, true, true, false, false, true);
	} else if (col.name === "currentNodesInfo") {//当前待办人
		return getCurrentNodesInfoTxt(txt, data);
	} else if (col.name === "summaryDeadLineName") {//流程期限
		return getListSummaryIsCoverTimeTxt(txt, data);
	} else if (col.name === "subState") {//状态
		return getListWaitState(txt, data);
	}
	return txt;
}

// 双击事件
function dbclickRow(data, rowIndex, colIndex) {
	if (colIndex == 11) {
		return;
	}

	if (!isAffairValid(data.affairId)) {
		reloadListGrid();
		return;
	}
	var _url = getListClickUrl(data, "listWaitSend");
	if (!_url) {
		return;
	}

	var _title = data.subject;
	openGovdocDialog(_url, escapeStringToHTML(_title));
	grid.grid.resizeGridUpDown('down');
}

function loadPendingGrid() {
	var url = window.location.search;
	var o = new Object();
	setParamsToObject(o, url);
	$("#listWaitSend").ajaxgridLoad(o);
}


