
/** *********************************** 公文列表数据显示处理 ************************************** */
/**
 * 列表-分类
 */
function getListGovdocTypeName(govdocType, subApp) {
	if(subApp == 1 || subApp == 19 || subApp == 22) {
		return $.i18n("govdoc.edocSend.label.js");
	} else if(subApp == 2 || subApp == 4 || subApp == 20 || subApp == 23 || subApp == 24 || subApp == 34) {
		return $.i18n("govdoc.edocRec.label.js");
	} else if(subApp == 3 || subApp == 21) {
		return $.i18n("govdoc.edocSign.label");
	} else {
		return $.i18n("taskmanage.govdoc.label");
	}
}
/**
 * 列表-标题
 * 0 txt/1 data/2 isColorBold/3 isProxy/4 isImportant/5 isAtt/6 isBodyType/7 isFlowState/8 isAffairDeadLineName/9 isAuthorityButton/10 linkTxt
 */
function getListSubjectTxt(txt, data, isColorBold, isProxy, isImportant, 
		isAtt, isBodyType, isFlowState, isAffairDeadLineName, isAuthorityButton, 
		isLinkA) {
	
	if(isLinkA) {
		txt = "<a class='card' href='#'  onclick='dbclickRow(this)' subject='"+escapeStringToHTML(data.subject)+"' affairId='"+data.affairId+"' affairObjectId='"+data.affairObjectId+"' affairSubObjectId='"+data.affairSubObjectId+"' affairApp='"+data.affairApp+"' affairSubApp='"+data.affairSubApp+"' govdocType='"+data.govdocType+"' summaryId='"+data.summaryId+"' >"+txt+"</a>";
	}
	// 标题列加深
	if (isColorBold) {
		txt = "<span class='grid_black titleText'>" + txt + "</span>";
	}

	// 如果是代理 ，颜色变成蓝色,并且不是取消代理的情况下
	if (isProxy && data.proxyMemberId != null) {
		if (data.proxy) {
			txt = "<span class='color_blue'>" + txt + "</span>";
		}
	}

	// 加图标(重要程度 1普通 2平急 3加急 4特急 5特提)
	if (isImportant) {
		if (data.importantLevel !== "" && data.importantLevel > 1
				&& data.importantLevel <= 5) {
			txt = "<span class='ico16 important" + data.importantLevel
					+ "_16 ' style='float: left;'></span>" + txt;
		}
	}

	// 加图标(附件)
	if (isAtt) {
		if (data.hasAtt === true) {
			txt = txt + "<span class='ico16 affix_16'></span>";
		}
	}

	// 表单授权
	if (isAuthorityButton) {
		if (data.showAuthorityButton) {
			txt = txt + "<span class='ico16 authorize_16'></span>";
		}
	}

	// 协同类型//注释屏蔽列表的正文类型图标
	if (isBodyType) {
		if(data.contentType!="" && data.contentType!=null && data.contentType!="10" && data.contentType!="30") {
	        txt = txt+ "<span class='ico16 office"+data.contentType+"_16'></span>";
	    }
	}

	// 加图标(流程状态)
	//公文管理自定义列表页面 条件判断条件去掉图标  data.summaryState 不等于 2
	if (isFlowState) {
		var subApp = data.affairSubApp;
		if((subApp == 1||subApp == 2||subApp == 3||subApp == 4||subApp == 19||subApp == 20||subApp == 21)) {//24老公文交换
			if (data.summaryState !== null && data.summaryState !== "" && data.summaryState != "0" && data.summaryState != "2") {
				txt = "<span class='ico16 flow" + data.summaryState + "_16 ' style='float:left;'></span>" + txt;
			}
		} else if(subApp == 22 || subApp == 23 || subApp == 24 || subApp == 34) {
			if (data.affairFinish==true || data.affairFinish == "true") {
				txt = "<span class='ico16 flow3_16 ' style='float:left;'></span>" + txt;
			}
		}
	}

	// 加图标(如果设置了处理期限(节点期限),添加超期图标)
	if (isAffairDeadLineName) {
		if (data.affairDeadLineName && data.affairDeadLineName != $.i18n('collaboration.project.nothing.label')) {
			if (data.affairIsCoverTime) {
				// 超期图标
				txt = txt + "<span class='ico16 extended_red_16'></span>";
			} else {
				// 未超期图标
				txt = txt + "<span class='ico16 extended_blue_16'></span>";
			}
		}
	}
	return txt;
}
/**
 * 列表(关联文档)-状态
 */
function getListAffairStateTxt(txt, data) {
	var affairState = data.affairState;
	if (affairState === 2) {
		txt = $.i18n("govdoc.Already.send");
	} else if (affairState === 4) {
		txt = $.i18n("govdoc.Already.done");
	} else {
		txt = $.i18n("govdoc.to-do");
	}
	return txt;
}

/**
 * 列表-加粗
 */
function getListBoldTxt(txt, data) {
	// 未读 11 加粗显示
	var subState = data.affairSubState;
	if (subState === 11 && txt != null && txt !="null") {
		txt = "<span class='font_bold'>" + txt + "</span>";
	}
	return txt;
}
/**
 * 列表-超期文字显示红色
 */
function getListRedColorTxt(txt, data) {
	if(txt == "") {
		txt = $.i18n("edoc.secretlevel.normal.GOV");
	}
	if (data.affairIsCoverTime) {
		// 超期图标
		txt = "<span class='color_red'>" + txt + "</span>";
	}
	return txt;
}
/**
 * 列表-超期文字显示红色
 */
function getListSummaryIsCoverTimeTxt(txt, data) {
	if(txt == "") {
		txt = $.i18n("edoc.secretlevel.normal.GOV");
	}		
	if (data.summaryIsCoverTime) {
		var title = $.i18n('collaboration.listsent.overtime.title');
		txt = "<span class='color_red' title='" + title + "'>" + txt
				+ "</span>";
	} else {
		var title = $.i18n('collaboration.listsent.overtime.no.title');
		txt = "<span title='" + title + "'>" + txt + "</span>";
	}
	return txt;
}
/**
 * 列表-剩余时间
 * @param data
 * @returns
 */
function getListSurplusTimeTxt(data) {
	if (data.surplusTime == null) {
		return $.i18n("govdoc.none.label");
	}
	if (data.surplusTime[0] <= 0 && data.surplusTime[1] <= 0 && data.surplusTime[2] <= 0) {
		if (data.affairIsCoverTime) {// 超期图标
			return "<span class='color_red'>" + $.i18n("govdoc.node.isovertime.label") + "</span>";
		} else {
			return $.i18n("govdoc.none.label");
		}
	}
	var time = "";
	if (data.surplusTime[0] != 0) {
		time = data.surplusTime[0] + $.i18n("govdoc.time.day.label");
		if(data.surplusTime[1] != 0){
			time = time + data.surplusTime[1] + $.i18n("govdoc.time.hour.label");
		}
	}else if (data.surplusTime[1] != 0) {
		time = data.surplusTime[1] + $.i18n("govdoc.time.hour.label");
		if(data.surplusTime[2] != 0){
			time = time + data.surplusTime[2] + $.i18n("govdoc.time.minute.label");
		}
	}else if (data.surplusTime[2] != 0) {
		time = data.surplusTime[2] + $.i18n("govdoc.time.minute.label");
	}
	return time;
}
/**
 * 列表-流程日志
 * @param data
 * @returns
 */
function getListProcessIdTxt(data) {
	if(data.affairSubApp == 22 || data.affairSubApp == 23 || data.affairSubApp == 24 || data.affairSubApp == 34){
		return $.i18n('govdoc.none.label');
	}
	if (null != data.processId) {
		return "&nbsp;<a class='ico16 view_log_16 noClick' href='javascript:void(0)' onclick='showDetailLogDialog(\""
		+ data.summaryId + "\",\"" + data.processId + "\",2,\""+data.fromType +"\",\""+data.affairSubApp +"\")'></a>&nbsp;";
	}
	return "";
}
/**
 * 列表-跟踪状态
 * @param data
 * @returns
 */
function getListTrackTxt(txt, data, hasLock) {
	var trackTxt = "";
	if (data.affairSubApp <= 21 ) {// 新公文和老公文 发文 才有跟踪
		// 添加跟踪的代码
		if (txt === null || txt === false || txt===0) {
			trackTxt = "<a href='javascript:void(0)' class='noClick' onclick='setTrack(this)' objState="
					+ data.affairState
					+ " affairId="
					+ data.affairId
					+ " summaryId="
					+ data.summaryId
					+ " trackType="
					+ data.trackType
					+ " senderId="
					+ data.startMemberId
					+ " fromType="
					+ data.fromType
					+ ">[" + $.i18n('message.no.js') + "]</a>";
		} else {
			trackTxt = "<a href='javascript:void(0)' class='noClick' onclick='setTrack(this)' objState="
					+ data.affairState
					+ " affairId="
					+ data.affairId
					+ " summaryId="
					+ data.summaryId
					+ " trackType="
					+ data.trackType
					+ " senderId="
					+ data.startMemberId
					+ ">[" + $.i18n('message.yes.js') + "]</a>";
		}
		trackTxt += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	}else{
		trackTxt = "";
	}
	if(listType.indexOf("listDone") != -1||listType.indexOf("listFinished")!=-1){
		if(data.affairSubApp == "22" || data.affairSubApp == "23" || data.affairSubApp == "24"){
			if(txt === null || txt === false || txt===0){
				return $.i18n('message.no.js');
			}else{
				return $.i18n('message.yes.js');
			}
			
		}
	}
	if(hasLock) {
		//2019年9月23日修改，只有新公文才有文单锁，解决OA-193062 新发的公文已发列表里没有显示文单锁查看
		if (data.affairApp == 4 && (data.affairSubApp == 1 || data.affairSubApp == 2 || data.affairSubApp == 3 || data.affairSubApp == 4)) {
			trackTxt += "<a href='javascript:void(0)' class='noClick' onclick='showGovdocFormLock(this)' objState="
					+ data.affairState
					+ " affairId="
					+ data.affairId
					+ " summaryId="
					+ data.summaryId
					+ " trackType="
					+ data.trackType
					+ " senderId=" + data.startMemberId + ">["+$.i18n("govdoc.single.lock.view")+"]</a>";
		}
	}
	return trackTxt;
}
/**
 * 列表-分送状态
 * @param data
 * @returns
 */
function getListDistributeStateTxt(data) {
	if(data.govdocType != 0) {
		if(data.exchangeSendAffairId && data.exchangeSendAffairId != "-1" || data.isQuickSend){
            if(listType.indexOf("listSent") > -1 && data.isQuickSend != true || data.competeDoneType == "no"){
                return "";
            }
			if(data.competeDoneType === null || data.competeDoneType === 'null'||data.competeDoneType == ""){
				if($.ctx.CurrentUser.id == data.affairMemberId){//当前人才能补发
					var returnTxt = "<a href='javascript:void(0)' class='noClick' onclick='showExchangeSendState(\"" + data.summaryId + "\",\"" + data.competeDoneType + "\",\""+data.fromType+"\")'>["+$.i18n("govdoc.lookOver")+"]</a>";
					returnTxt = returnTxt + "  <a href='javascript:void(0)' class='noClick' onclick='exchangeReissue(\"" + data.summaryId + "\",\""+data.fromType+"\")'>["+$.i18n("govdoc.Reissue")+"]</a>";
					return returnTxt;
				}

			} else if(data.competeDoneType === 'OtherDone' || data.competeDoneType === 'AllDone'||data.competeDoneType === 'other'){
				return "<a href='javascript:void(0)' class='noClick' onclick='showExchangeSendState(\"" + data.summaryId + "\",\"" + data.competeDoneType + "\",\""+data.fromType+"\")'>["+$.i18n("govdoc.lookOver")+"]</a>";
			}

		}
	}
	return "";
}
/**
 * 列表-当前待办人
 * @param data
 * @returns
 */
function getCurrentNodesInfoTxt(txt, data) {
	var titleTemp = txt;
	txt = txt.replace("...", "");
	var hasEnd =  $.i18n("govdoc.Hasended");
	if(listType.indexOf("listDone") != -1){
		if(data.affairSubApp == "22" || data.affairSubApp == "23" || data.affairSubApp == "24"){
			return hasEnd;
		}else{
		    if(data.affairSubApp == "4" && data.completeTime != null){//签收自定义节点流程结束还显示当前待办人
		        txt = hasEnd;
		    }
		}
	}
	if (null != data.processId && data.isQuickSend==false) {
		return "<a href='javascript:void(0)' class='noClick' title='"
				+ titleTemp + "' onclick='showFlowChart(\""
				+ data.caseId + "\",\"" + data.processId + "\",\""
				+ data.templeteId + "\",\"" + data.activityId + "\",\"" + data.fromType +"\")'>"
				+ txt + "</a>";
	}
	return txt;
}

function getListWaitState(txt, data) {
	return $.i18n("collaboration.substate.new."+data.affairSubState+".label");
}

/** *********************************** 公文列表数据点击事件 ************************************** */
//取消加粗
function cancelBold(listId, rowIndex) {
	var obj = $("#"+listId+" tr:eq(" + rowIndex + ")").find(".font_bold");
	if (obj != null && typeof (obj) != 'undefined') {
		obj.removeClass("font_bold");
	}
}

function getListClickUrl(data, openFrom) {
	var app = data.affairApp;
	var govdocType = data.govdocType;
	var url = "";
	if (app == 4) {// 新公文 //根据 app 判断对应的公文种类
		var subApp = data.affairSubApp;
		if(govdocType != 0) {
			url = edocURL + "?method=summary";
			if(data.affairId) {
				url += "&affairId=" + data.affairId;
			} else if(data.summaryId) {
				url += "&summaryId=" + data.summaryId;
			}
			if(!(data.competeDoneType === null) && data.competeDoneType !="no")
			{		
				//ToDo James 竞争穿透
				url += "&openFrom=listDone";
				url += "&competeDoneType="+data.competeDoneType;//竞争不执行的操作控制
			} else if(openFrom) {
				url += "&openFrom=" + openFrom;
			}
		} else {
			url = getOldUrl("view", openFrom, subApp, data.summaryId, data.affairId, data.affairObjectId, data.affairSubObjectId,null,data.menuId);
			if(!url) {
				return;
			}	
		}
	} else {
		url = getOldUrl("view", openFrom, app, data.summaryId, data.affairId, data.affairObjectId, data.affairSubObjectId,null,data.menuId);
		if(!url) {
			return;
		}
	} 
	return url;
}

function getOldUrl(action, openFrom, subApp, summaryId, affairId, objectId, subObjectId, subState,fromMenuId) {
	var url = "";
	openFrom = openFrom == "listPending" ? "Pending" : openFrom;
	if(action == "view") {
		if (subApp == 19 || subApp == 20 || subApp == 21) {//G6老公文-发文/收文/签报
			if(openFrom == "formStatistical") {
				openFrom = "glwd";
			}
			url = _ctxPath + "/edocController.do?method=detailIFrame&from=" + openFrom;
			if(affairId) {
				url += "&affairId=" + affairId;
			} else if(summaryId) {
				url += "&summaryId=" + summaryId;
			}
		} else if (subApp == 22) { //G6老公文-交换
			if(openFrom.indexOf("Pending") >= 0) {//待发送
				url = _ctxPath + "/exchangeEdoc.do?method=sendDetail&modelType=toSend&id=" + subObjectId + "&affairId=" + affairId;
			} else {//已发送
				url = _ctxPath + "/exchangeEdoc.do?method=edit&id="+subObjectId+"&modelType=sent";
			}
		} else if (subApp == 23) {//G6老公文-签收
			if(openFrom.indexOf("Pending") >= 0) {//待签收
				url = _ctxPath + "/exchangeEdoc.do?method=receiveDetail&modelType=toReceive&userId=&id=" + subObjectId+"&affairId=" + affairId;
			} else {//已签收
				url = _ctxPath + "/exchangeEdoc.do?method=edit&modelType=received&userId=&id=" + subObjectId + "&affairId=" + affairId;
			}
		} else if (subApp == 24) {//G6老公文-登记
			if(openFrom.indexOf("Pending") >= 0) {//待登记
				url = _ctxPath + "/edocController.do?method=newEdocRegister&edocType=1&affairId=" + affairId
						+ "&listType=newEdocRegister&recListType=registerPending&comm=create&edocId="+ summaryId + "&registerType=1";
				if(fromMenuId){
					url = url + "&fromMenuId="+fromMenuId;
				}
				if(parent && parent._resourceCode) {
					url += "&_resourceCode=" + parent._resourceCode;
				}
				//parent.window.location.href = url;
                openCtpWindow({'url':url});
				return;
			} else {//已登记
				if(subObjectId == null) {
					subObjectId = "";
				}
				if(objectId == null) {
					objectId = "";
				}
				url = _ctxPath + "/edocController.do?method=edocRegisterDetail&forwardType=registered&recieveId=" + subObjectId + "&registerId=" + objectId;
			}
		} else if (subApp == 34) {// 待登记 草稿
			if(openFrom.indexOf("Pending") >= 0) {//待登记
				url = _ctxPath + "/edocController.do?method=entryManager&isFromHome=true&entry=recManager&toFrom=newEdoc&listType=newEdoc&recListType=listDistribute&app=34&id=" + summaryId + "&affairId=" + affairId;
				if(fromMenuId){
					url = url + "&fromMenuId="+fromMenuId;
				}
				if(parent && parent._resourceCode) {
					url += "&_resourceCode=" + parent._resourceCode;
				}
				parent.window.location.href = url;

				return;
			} else {//已分发
				url = _ctxPath + "/edocController.do?method=edocRegisterDetail&forwardType=registered&registerId=" + summaryId;
			}
		}
	} else if(action == "edit") {
		if (subApp == 19 || subApp == 20 || subApp == 21) {//老公文编辑
			if (subApp == 19) {//老公文-发文-待登记-编辑
				url = _ctxPath + "/edocController.do?method=entryManager&isFromHome=true&entry=sendManager&toFrom=newEdoc&listType=newEdoc&app=19&sub_app=1&summaryId=" + summaryId + "&affairId=" + affairId;
			} else if (subApp == 20) {//老公文-收文-待登记-编辑
				url = _ctxPath + "/edocController.do?method=entryManager&isFromHome=true&entry=recManager&toFrom=newEdoc&listType=newEdoc&recListType=listDistribute&app=20&sub_app=2&summaryId=" + summaryId + "&affairId=" + affairId+"&subState="+subState;
			} else if (subApp == 21) {//老公文-签报-待发-编辑
				url = _ctxPath + "/edocController.do?method=entryManager&isFromHome=true&entry=signReport&toFrom=newEdoc&listType=newEdoc&app=21&sub_app=3&summaryId=" + summaryId + "&affairId=" + affairId;
			}
			if(fromMenuId){
				url = url + "&fromMenuId="+fromMenuId;
			}
			if(parent && parent._resourceCode) {
				url += "&_resourceCode=" + parent._resourceCode;
			}
			parent.window.location.href = url;
			return;
		} else if (subApp == 24) {//G6老公文-登记
			url = _ctxPath + "/edocController.do?method=newEdocRegister&edocType=1&affairId=" + affairId
			+ "&listType=newEdocRegister&recListType=registerPending&comm=create&edocId="+ summaryId + "&registerType=1";
			parent.window.location.href = _ctxPath = url;
			return;
		} 
	}
	return url;
}

//判断当前窗口是否打开了
function exitWinOpen(affairId) {
	var _wmp = getCtpTop()._windowsMap;
	if(_wmp){
		//参考common-debug.js修改
		try {
			var _wmpKeys= _wmp.keys();
		} catch(e) {//兼容处理，为了解决bug：OA-80754公司协同：连续打开2个新闻、2个公告，页签不关闭，这时，首页待办栏目中的标题点不动，栏目空间都可以刷新。
			getCtpTop()._windowsMap= new Properties();
			_wmp = getCtpTop()._windowsMap;
		}
  	
		//不存在的情况删除之前打开的信息
		for(var p = 0;p<_wmp.keys().size();p++) {
			var _kkk = _wmp.keys().get(p);
			try {
              var _fff = _wmp.get(_kkk);
              var _dd = _fff.document;
              if(_dd) {
                  var _p = parseInt(_dd.body.clientHeight);
                  if(_p == 0){
                      _wmp.remove(_kkk);
                      p--;
                  }
              } else {
                  _wmp.remove(_kkk);
                  p--;
              }
          } catch(e) {
              _wmp.remove(_kkk);
              p--;
          }
      }

      var exitWin = _wmp.get(affairId);
      if(exitWin) {
          try {
              alert($.i18n("window.already.exit.js"));
              exitWin.focus();
              return false;
          } catch(e){}
      }
  }
  return true;
}

function colseQuery() {
	try{
		var dialogTemp=window.parentDialogObj['queryDialog'];
		dialogTemp.close();
	} catch(e){}
}

function openGovdocDialog(url ,title) {
    var parmas = [$('#summary'), $('.slideDownBtn'), $('#listPending')];
//    if(getA8Top().showSummayDialogByURL) {
//    	getA8Top().showSummayDialogByURL(url,title,parmas);	
//    } else {
//    	showSummayDialogByURL(url,title,parmas);
//    }
    try{
        //公文、协同都是affairId，会议是Id
        var affairIdIndex = url.indexOf("affairId");
        var idIndex = url.indexOf("id");
        var id = "";
        if (affairIdIndex != -1)  {
            id = getMultyWindowId("affairId",url);
            openCtpWindow({'url':url,'id':id});
        } else if (idIndex != -1) {
            id = getMultyWindowId("id",url);
            openCtpWindow({'url':url,'id':id});
        } else {
            openCtpWindow({'url':url});
        }
    } catch (e) {
    }
}

/**
 * 通过url打开协同正文
 * dialog方式打开
 * parmas
 */
function showSummayDialogByURL(url,title,params){
    try{
        //公文、协同都是affairId，会议是Id
        var affairIdIndex = url.indexOf("affairId");
        var idIndex = url.indexOf("id");
        var id = "";
        if (affairIdIndex != -1)  {
            id = getMultyWindowId("affairId",url);
            openCtpWindow({'url':url,'id':id});
        } else if (idIndex != -1) {
            id = getMultyWindowId("id",url);
            openCtpWindow({'url':url,'id':id});
        } else {
            openCtpWindow({'url':url});
        }
    } catch (e) {
    }
}

/**
 * 明细日志 弹出对话框
 * showFlag  初始化时 显示的内容 1:显示处理明细 2:显示流程日志 3:显示催办(督办)日志
 */
function showDetailLogDialog(summaryId, processId, showFlag,fromType,appTypeName) {
	if(fromType=='3'||fromType==='3'||fromType==3){
		alert($.i18n("govdoc.out.process.cannot"));
		return;
	}
    var dialog = $.dialog({
        url : _ctxPath+'/detaillog/detaillog.do?method=showDetailLog&summaryId='+summaryId+'&processId='+processId+"&showFlag="+showFlag+"&appName=4&appTypeName="+appTypeName,
        width : 1040,
        height : 400,
        title : $.i18n('collaboration.sendGrid.findAllLog'), //查看明细日志
        targetWindow:getCtpTop(),
        buttons : [{
            text : $.i18n('collaboration.button.close.label'),
            handler : function() {
              dialog.close();
            }
        }]
    });
}
//显示流程图
function showFlowChart(_contextCaseId,_contextProcessId,_templateId,_contextActivityId,fromType){
	if(fromType=='3'||fromType==='3'||fromType==3){
		alert($.i18n("govdoc.out.process.cannot"));
		return;
	}
    var showHastenButton='false';
    var supervisorsId="";
    var isTemplate=false;
    var operationId="";
    var senderName="";
    var openType=getA8Top();
    if(_templateId&&"undefined"!=_templateId){
        isTemplate=true;
    }
    var showHisWorkflow = false;
    //showWFCDiagram(openType,_contextCaseId,_contextProcessId,isTemplate,showHastenButton,supervisorsId,window, 'collaboration', false ,_contextActivityId,operationId,'' ,senderName);
    var options = { 
    	      targetWin:getA8Top(), 
    	      caseId:_contextCaseId, 
    	      processId:_contextProcessId, 
    	      isTemplate:isTemplate, 
    	      showHastenButton:showHastenButton, 
    	      appName:"edoc", 
    	      currentNodeId : _contextActivityId, 
    	      isHistoryFlag : showHisWorkflow, 
    	      scene:3, 
    	      SPK:'0' 
    	     } 
    showDiagram(options); 
}

/**
 * 设置跟踪
 * @param obj
 */
function setTrack(obj){
	var fromType = $(obj).attr("fromType");
	if(fromType=='3'||fromType==='3'||fromType==3){
		alert($.i18n("govdoc.out.exchange.cannotresend"));
		return;
	}
     var text = $(obj).text();
     var affairId = $(obj).attr("affairId");
     var summaryId = $(obj).attr("summaryId");
     var dialog = $.dialog({
          targetWindow:getCtpTop(),
          id: 'trackDialog',
          url: edocURL + '?method=openTrackDetail&objectId='+summaryId+'&affairId='+affairId,
          width: 200,
          height: 100,
          title: $.i18n('collaboration.listDone.traceSettings'),
          buttons: [{
              id : "trackSubmit",
              text: $.i18n('collaboration.pushMessageToMembers.confirm'), //确定
              handler: function () {
                 var returnValue = dialog.getReturnValue();
                 if( returnValue && returnValue != null){//返回值到父页面
                     if(returnValue == '1' || returnValue =='2'){
                         $(obj).text("[" + $.i18n('message.yes.js') + "]"); //是
                     } else {
                         $(obj).text("[" + $.i18n('message.no.js') + "]"); //否
                     }
                     try{
                         $("#trackType",window.summaryF.document).val(newTrackType);
                     }catch(e){}
                     dialog.close();
                 }
              }
          }, {
              text: $.i18n('collaboration.pushMessageToMembers.cancel'), //取消
              handler: function () {
                  dialog.close();
              }
          }]
      });
}

/**
 * 文单锁查看
 * @param obj
 */
function showGovdocFormLock(obj) {
	var summaryId = obj.getAttribute("summaryId");
	var formLockDialog = $.dialog({
        url : edocListURL + '?method=listGovdocformLock&summaryId='+summaryId,
        width : 500,
        height : 300,
        title : $.i18n("govdoc.lookOver"),
        targetWindow:getCtpTop(),
        buttons : [{
            text : $.i18n('collaboration.button.close.label'),
            handler : function() {
            	formLockDialog.close();
            }
        }]
    });
}

//ajax判断事项是否可用。
function isAffairValid(affairId) {
	return true;
}

function showExchangeSendState(summaryId,competeDoneType,fromType){
	if(fromType=='3'||fromType==='3'||fromType==3){
		alert($.i18n("govdoc.out.process.cannot"));
		return;
	}
	var url = '';
	var dialog = $.dialog({
        url : _ctxPath + "/govdoc/exchange.do?method=showExchangeSendState&summaryId=" + summaryId + "&competeDoneType="+competeDoneType,
        width : 1000,
        height : 400,
        title : $.i18n('govdoc.exchange.send.state.label'),
        targetWindow:getCtpTop(),
        buttons : [{
            text : $.i18n('collaboration.button.close.label'),
            handler : function() {
              dialog.close();
            }
        }]
    });
}

function exchangeReissue(summaryId,fromType){
	if(fromType=='3'||fromType==='3'||fromType==3){
		alert($.i18n("govdoc.out.exchange.cannotresend"));
		return;
	}
	$.selectPeople({
        panels: 'OcipOrganization,Account,Department,OrgTeam',
        selectType: 'Account,Department,OrgTeam',
        hiddenPostOfDepartment:true,//隐藏岗位
        showAllOuterDepartment:true,//显示所有外部单位
        isCanSelectGroupAccount:false,//是否可选集团单位
        unallowedSelectEmptyGroup:true,//不允许为空
        isConfirmExcludeSubDepartment:false,
        isAllowContainsChildDept:true,
        isCheckInclusionRelations:false,
        callback : function(ret) {
        	var exchange = new govdocExchangeManager();
        	var result = exchange.validateReissueeRepeat(summaryId,ret.value);
        	if(result!=null){
        		var con = $.messageBox({
        			'imgType':'3',
        			'type': 100,
        			'msg': $.i18n('govdoc.exchange.reissueConfirm.label',result.names),
        			buttons: [{
        			    id:'btn1',
        			        text: $.i18n('message.yes.js'),
        			        handler: function () {
        			        	send2Account(exchange,summaryId,ret.value);
        			        	con.close();
        			        }
        			    }, {
        			    id:'btn2',
        			        text: $.i18n('message.no.js'),
        			        handler: function () {
        			        	if(result.values!=ret.value&&result.values!=""){
        			        		send2Account(exchange,summaryId,result.values);
        			        	}
        			        	con.close();
        			        }
        			    }, {
        			    id:'btn3',
        			        text: $.i18n('message.cancel.js'),
        			        handler: function () {con.close();}
        			    }]
        		});
			}else{
				send2Account(exchange,summaryId,ret.value);
			}
        	
        }
    });
}

function send2Account(exchange,summaryId,retVal){
	var proce = $.progressBar();
	exchange.exchangeReissue(summaryId,retVal);
    proce.close();
	var win = new MxtMsgBox({
	    'type': 0,
	    'imgType':0,
	    'msg': $.i18n('govdoc.exchange.hasSent.label'),
	    ok_fn:function(){
	    }
	});
}

/**
 * 加载转发文和转事务按钮
 * @param toolbarArray
 */
function loadTransSendGovdocAndCollToolbar(toolbarArray) {
	if(govdocType=="" || govdocType.indexOf("2") > -1){
		if ($.ctx.CurrentUser.userRoles.contains('SendEdoc') || $.ctx.CurrentUser.userRoles.contains('EdocQuickSend')) {
			toolbarArray.push({//转发文
				id : "forwardText",
				name : $.i18n('govdoc.button.forwardText.label'),
				className : "ico16 forwarding_16",
				click : doForward
			});
		}	
	}
	if($.ctx.resources.contains('F01_newColl')) {
		toolbarArray.push({//转事务
			id : "forwardCol",
			name : $.i18n('govdoc.button.forwardCol.label'),
			className : "ico16 read_switch_office_16",
			click : doForwardCol
		});
	}
}
function listAddWaterMark(tableId){
	addWaterMark({appType : 'edoc', isMobile : false, imgInfo : true}, function(rs){
		if (rs && rs.show) {
			$("."+"bDiv").css('backgroundImage', 'url(' + rs.img + ')');
		}
	});	
}
//是否显示归档按钮
function isShowPigeonhole(){
	return $.ctx.resources.contains('F04_docIndex')
	|| $.ctx.resources.contains('F04_docHomepageIndex')
	|| $.ctx.resources.contains('F04_docLibsConfig')
	|| $.ctx.resources.contains('F04_myDocLibIndex')
	|| $.ctx.resources.contains('F04_eDocLibIndex')
	|| $.ctx.resources.contains('F04_accDocLibIndex')
	|| $.ctx.resources.contains('F04_proDocLibIndex');
}
function loadLayoutListCss(){
	var head = document.getElementsByTagName('head')[0],　　
	  link = document.createElement('link');　　　　　　　　　　　　
	  link.href = "/seeyon/apps_res/govdoc/css/govdoc_list_layout.css";　　　　　　　　　　　　　　　　　　　　　　　
	  link.rel = 'stylesheet';
	  head.appendChild(link);
}