
var configs;
function loadListConfigTab() {
	if(listType == "listPendingAllRoot" || listType == "listDoneAllRoot") {
		var manager = new govdocListConfigManager();
		configs = manager.getListConfigs(listType);
		var right = 0;
		if(configs && configs.length>0) {
			for(var i=0; i<configs.length; i++) {
				var config = configs[i];
				var buffer = "";
				if(config.configName == "govdoc.pending.all") {
					buffer += '<li id="'+config.linkType+'RootTab" class="current"><a id="'+config.linkType+'AllA" hideFocus="true" href="javascript:void(0)" tgt="main" class="no_b_border" url="govdoc.do?method=list&listType='+config.linkType+'Root"><span>'+config.name+'</span></a></li>';
				} else if(config.configName == "govdoc.done.all") {
					buffer += '<li id="'+config.linkType+'RootTab" class="current"><a id="'+config.linkType+'AllA" hideFocus="true" href="javascript:void(0)" tgt="main" class="no_b_border" url="govdoc.do?method=list&listType='+config.linkType+'Root"><span>'+config.name+'</span></a></li>';
				} else {
					var _url = edocURL + "?method=list&listType="+listType+"&configId="+config.id;
					buffer += "<li id='"+listType+i+"' configId='"+config.id+"' custom='true' style='position:relative;display: inline-block'>";
					buffer += "<a url='" + _url + "'>"+config.name+"</a>";
					buffer += "<span class='ico16 canceled_16' style='position:absolute;top:10;right:"+right+"px;z-index:10;' title="+$.i18n('govdoc.opinion.del')+" configId='"+config.id+"'></span>";
					buffer += "</li>";
				}
				
				$("#tabUL").append(buffer);
			}
		}
		
		$("#add_column").unbind("click").bind("click", function() {
			addListConfig();
		});
	}
}

function showIcon(){
    $("#tabs_head").find("li[custom='true']").each(function(){
	    $(this).find("span").hide();
    }).hover(function() {
		$(this).find("span").show();
	}, function() {
		$(this).find("span").hide();
	});
}

function loadTabEvent() {
    $("#tabs").find("li").each(function() {
		var _this = $(this);
		_this.bind("click", function() {
			reloadFrame(this);
		});
		_this.find("span.canceled_16").unbind("click").bind("click", function() {
			deleteListConfig(this);
		});
	});
	showIcon();
}

function reloadFrame(obj) {
	$("#tabs").find("li").each(function() {
		 var _this = $(this);
		 _this.removeClass("current");
	});
	
	var _this = $(obj);
	_this.addClass("current");
	
 	var _url = _this.find("a").attr("url");
    $("#main").attr("src", _url);
};

function loadFirstTabEvent() {
	if(listType && listType != "") {
		var tabId = (listType + "Tab");
		$("#tabs").find("#"+ tabId).trigger("click");
	} else {
		$("#tabs").find("li").eq(0).trigger("click");
	}
}

function loadUE() {
	if(listType == "listSentAllRoot" || listType == "listWaitSendAllRoot") {
		$("#layout").layout().setNorth(0);
		$("#main").height($("#layout").height());
	}
}

/**
 * 添加列表分类配置
 */
function addListConfig() {
	var dialog = $.dialog({
        targetWindow : getCtpTop(),
        url: edocListURL + "?method=openListConfigDialog&listType=" + listType, 
		width: 570,
		height: 350,
        title:$.i18n('govdoc.classification.configuration'),
        buttons: [{
			id : "btn1",
            btnType:"1",
            text: $.i18n("govdoc.determine"), //确定
            handler: function () {
            	var rv = dialog.getReturnValue();
            	if(rv!=0 && rv!=null && rv!=""){
					var o = new Object();
	            	o.listType = listType;
	            	o.permissions = rv.find("#permissions").val();
	            	o.configName = rv.find("#configName").val();
	            	
	            	var manager = new govdocListConfigManager();
	            	var result = manager.saveListConfig(o);
	            	if(result == "repeat") {
	            		alert($.i18n("govdoc.category.repeat.canNot"));
	            	} else if(result == "false") {
	            		alert($.i18n("govdoc.add.fail"));
	            	} else {
	            		dialog.close();
           				location.reload(); 
	            	}
				}
			}
		}, {
			text:$.i18n("govdoc.canArchive.label.cancel"), //取消
            handler: function () {
            	dialog.close();
			}
		}]
	});
}

/**
 * 删除列表分类配置
 * @param obj
 * @param evt
 */
function deleteListConfig(obj) {
	var configId = $(obj).attr("configId");
	if(configId == "") {
		return;
	}
	var manager = new govdocListConfigManager();
	manager.deleteListConfig(configId);
	
	if($("#tabs").find("li[configId='"+configId+"']") 
			&& $("#tabs").find("li[configId='"+configId+"']").hasClass("current")) {
		loadFirstTabEvent();
	}
	$("#tabs").find("li[configId='"+configId+"']").remove();
	
	var newConfigs = [];
	var j = 0;
	for(var i=0; i<configs.length; i++) {
		var config = configs[i];
		if(config.id != configId) {
			newConfigs[j++] = config;
		}
	}
	configs = newConfigs;
	
	$("#tabs").find("li[custom='true']").each(function() {
		var _this = $(this);
		var right = 0;
		
		for(var i=0; i<newConfigs.length; i++) {
			if(_this.attr("configId") == newConfigs[i].id) {
				// right = (newConfigs.length - i - 1) * 70;
				_this.find("span").css("right", right + "px");	
				break;
			}
		}
	});
}