/**
 * 按钮原子操作执行方法
 * 
 * @param operation
 * @returns
 */
function _operation_originalClickFn(atomicCode, config) {

	// 原子操作映射关系
	var code2Click = {
		"ContinueSubmit" : "send",
		"Comment": "saveDraft"
	}

	var clickFn = code2Click[atomicCode];

	if (clickFn && typeof window[clickFn] === "function") {

		config = config || {};
		var data = config.data;

		// 执行原子操作
		window[clickFn](data);

	} else {
		if (!clickFn) {
			alert($.i18n("govdoc.Xml.defined.operation") + atomicCode + $.i18n("govdoc.not.define.click"));
		} else {
			alert($.i18n("govdoc.Xml.defined.operation.notFind") + atomicCode + $.i18n("govdoc.not.define.click") + "["
					+ clickFn + "]");
		}
	}
}

/**
 * 按钮显示时按钮置灰校验
 * @param operation
 * @returns
 */
function _operation_filterFn(operation, category){
    var disabled = false;
    var remove = false;    
    var ret = {disabled : disabled, remove : remove}
    return ret;
}

/**
 * 封装动作执行前的校验
 * @param wrapContent
 * @returns
 */
function _operation_packageOperationCheck(wrapContent){
    
    var msg = "";

    var ret = {result : true};
    
    if(msg != ""){
        $.alert(msg);
        ret.result = false;
    }
    
    return ret;
    
}
/**
 * 封装操作， 预提交数据
 * @returns
 */
function _operation_preSubmitData(wrapContent, config){
	config.success();
}

/**
 * 获取加签/当前会签/知会/多级会签 流程的时候需要设置流程的参数
 * @returns
 */
function _operation_getChangeWorkflowParamFn(type) {
    // 指定回退状态
    var changeWorkflowParam = {
        workitemId : "-1",
        processId : "-1",
        nodeId :"-1",
        caseId : "-1",
        appName : "edoc",
        isForm : true,
//        callback : resetProcessXml,
        affairId : "-1",
        useNowexpirationTime : "true",
        NPS:"default"
    }
    
    var tempSPK = "";
    switch (type) {
    case "AddNode":
        tempSPK = "insertNode"
        break;
    case "Infom":
        tempSPK = "informNode"
        break;
    case "JointSign":
        tempSPK = "assignNode"
        break;
    case "moreSign":
        tempSPK = "nodeOperation4Account";
        if(!$.ctx.CurrentUser.isAdmin){
            tempSPK = "nodeOperation4Form";
        }
        break;
    default:
        break;
    }
    changeWorkflowParam.SPK = tempSPK;
    
    if(type == "AddNode" || type == "Infom" || type == "JointSign"){
        changeWorkflowParam.performer = $.ctx.CurrentUser.id;
        changeWorkflowParam.summaryId = summaryId;
        changeWorkflowParam.formRecordId = "-1";
    }else{
        // 多级会签独有的参数
        changeWorkflowParam.affairMemberId = $.ctx.CurrentUser.id;
        changeWorkflowParam.workitemId = "-1";
        changeWorkflowParam.flowPermAccountId = $.ctx.CurrentUser.loginAccount;
//        changeWorkflowParam.callBackFn = resetProcessXml;
        changeWorkflowParam.selectPeopleDialogLeftTitle  = "";
        changeWorkflowParam.panels = "Department,Team,BusinessDepartment";
    }
    
    if(type == "Infom"){
        changeWorkflowParam.defaultPolicyId = "shenpi";
    }else if(type == "JointSign" ){
        changeWorkflowParam.defaultPolicyId = defaultPolicyId;
        changeWorkflowParam.defaultPolicyName = defaultPolicyName;
    }
    
    if(type == "AddNode" || type == "JointSign"){
        
        changeWorkflowParam.accountId = $.ctx.CurrentUser.loginAccount
        
    }else if(type == "moreSign"){
        
        changeWorkflowParam.accountId = $.ctx.CurrentUser.loginAccount;
        
    }else if(type == "Infom"){
        changeWorkflowParam.accountId = $.ctx.CurrentUser.loginAccount;
    }
    
    
    if(type == "AddNode" || type == "moreSign"){
        changeWorkflowParam.isTemplete = isSystemTemplate; 
    }
    changeWorkflowParam.customProcessAction = _operation_processAction;
    return changeWorkflowParam;
}
/**
 * 修改xml
 * @param type
 * @returns
 */
function _operation_processAction(processAction,changeWorkflowParam) {
	switch (processAction) {
	case "AddNode":
		//加签
//		var tprocess_xml_input= $("#process_xml",window.document)[0];
//		if(tprocess_xml_input.value != ""){
			addNode(changeWorkflowParam);
//		}else{
//			customAddNode(changeWorkflowParam.changeNodeMessage);
//		}
		break;
	case "JointSign":
		
		// 当前会签
		changeWorkflowParam.changeNodeMessage.policyId = changeWorkflowParam.defaultPolicyId;
		changeWorkflowParam.changeNodeMessage.policyName = changeWorkflowParam.defaultPolicyName;
		
		assignNode(changeWorkflowParam);
		break;
	case "moreSign":
		// 多级会签
		multistageSign(changeWorkflowParam);
		break;
	case "Infom":
		// 知会
		informNode(changeWorkflowParam);
		break;
	default:
		break;
	}
}
function customAddNode(changeNodeMessage){
	var selectValues = "";
	if(changeNodeMessage){
		var tempTypeArray = changeNodeMessage.userType, tempIdArray = changeNodeMessage.userId;
		if(tempTypeArray!=null && tempIdArray!=null){
			var tempArray = [];
			for(var i=0,len=tempTypeArray.length; i<len; i++){
				tempArray.push(tempTypeArray[i]+"|"+tempIdArray[i]);
			}
			selectValues = tempArray.join(",");
		}
	}
	var wfAjax= new WFAjax();
	var gAjaxManager = new govdocAjaxManager();
	var allMembers;

	//如果勾选了竞争执行
	var isCompetition = false;
	for(var i=0;i<changeNodeMessage.node_process_mode.length;i++){
		if(changeNodeMessage.node_process_mode[i] == "competition"){
			isCompetition = true;
			break;
		}
	}
	var url = _ctxPath+"/workflow/designer.do?method=showWorkFlowInsertPeopleSelectPage";
	var width = 400;
	var height = 300;
	var edocAddNodeStyle = "0";
	if (changeNodeMessage.addMember=="1") {
		width = 800;
		height = 400;
		if(isCompetition){
			allMembers = gAjaxManager.selectMember4OprationChangeProcess(selectValues,"-1","-1");
		}else{
			allMembers = wfAjax.selectMember4OprationChangeProcess(selectValues,
					"-1", "-1");
		}
		edocAddNodeStyle = "1";
	} else {
		allMembers = wfAjax.selectMember4OprationChangeProcess(selectValues,
				"-1", "-1");
	}
	var canSelectMember = changeNodeMessage.addMember == "1";
	url += "&edocAddNodeStyle="+edocAddNodeStyle;
	var  selectOprationMemberdialog = $.dialog({
		id: 'workflow_dialog_showWorkFlowInsertPeopleSelectPage_Id',
		isFromModle: true,
		url : url,
		width : width,
		height : height,
		title : changeNodeMessage.label,
		transParams : {
			"allMembers": allMembers,
			"canSelectMember":canSelectMember + "",
			"appName" : appName,
			"changeNodeMessage": changeNodeMessage
		},
		targetWindow : getCtpTop(),
		buttons : [{
			text : $.i18n('common.button.ok.label'),
			isEmphasize : true,
			handler : function() {
				var addMembers= selectOprationMemberdialog.getReturnValue({"innerButtonId":"ok"});
				if(addMembers==undefined){
					return;
				}
				if(addMembers!="{}"){
					var _process_info_val = $("#process_info").val();
					if(_process_info_val =="" || _process_info_val == "<点击新建流程>"){//新流程
						var res = new Object();
						res.obj =new Array();
						res.obj.push([]);
						if(changeNodeMessage.flowType == "1"){//串行
							res.obj.push(0);
						}else{//并行
							res.obj.push(1);
						}
						for(var i=0;i<changeNodeMessage.userId.length;i++){
							var row = new Object();
							row.nodePolicyId = changeNodeMessage.policyId;
							row.nodePolicyName =  $.trim(changeNodeMessage.policyName);
							row.id = changeNodeMessage.userId[i];
							row.name = changeNodeMessage.userName[i];
							if(changeNodeMessage.userType[i]){
								row.type = changeNodeMessage.userType[i];
								row.processMode=changeNodeMessage.node_process_mode[i];
							}else{
								row.type = "Member";
							}
							if(row.type == "Member"){
								row.processMode="single";
							}
							row.accountId = changeNodeMessage.accountId[i];
							res.obj[0].push(row);
						}
						createProcessXmlCallBack1(window,res,"edoc",window,"","","",changeNodeMessage.policyId,"",$.trim(changeNodeMessage.policyName),"","",res.obj[0],formAppId);
						window.distroy_token = true;
						if(changeNodeMessage.nextAction){
							changeNodeMessage.nextAction();
						}
					}else{//已经选过一次人的情况下 加签
						if($("#process_xml").val()==""){//说明有手选的流程
							tidyDatas("process_info",changeNodeMessage.policyId,changeNodeMessage.policyName);
						}
						assignNodeOpe("", "-1", "start", $.ctx.CurrentUser.id, "", "edoc", false, "", $.ctx.CurrentUser.loginAccount, null, summaryId,"-1",changeNodeMessage,1);
						var options = {
								targetWin : getCtpTop(),
								valueWin : window,
								appName : appName,
								isTemplate : false,
								currentUserId : $.ctx.CurrentUser.id,
								currentUserName : $.ctx.CurrentUser.name,
								currentAccountName:$.ctx.CurrentUser.loginAccountName,
								flowPermAccountId:$.ctx.CurrentUser.loginAccount,
								processId :"-1",
								defaultPolicyId : defaultPolicyId,
								defaultPolicyName : defaultPolicyName,
								scene : 1,
								SPK:"0",
								callBackFn : changeNodeMessage.nextAction,
								buttons:[{"id":"ok"}]
						};
						showDiagram(options);
						window.distroy_token = true;
					}
				}
				selectOprationMemberdialog.close();			
			}
		},{
			text : $.i18n('common.button.cancel.label'),
			handler : function() {        
				selectOprationMemberdialog.close();
			}
		}]
	});
}
/**
 * 修改流程前事件
 * @param type
 * @returns
 */
function _operation_beforeChangeWorkflowFn(type) {
	return true;
}
/***
 * 获取页面上的态度 input dom
 * @param attitudeAction 封装的态度 code
 * @param attitudeShowName 分装的态度名称
 * @returns
 */
function _operation_getAttitudeDomsFn(){
	return [];
}

/**
 * 设置态度的值
 * @param value
 * @param code
 * @returns
 */
function _operation_setAttitudeFn(value, code, isClear){
    
}

function refreshWorkflow(){
	
}

/**
 * 展现流程图的方法
 * @returns
 */
function _operation_refreshWorkflowFn(){
}
var insertNodeParams;
function addNode(param){
	if(validateProcess()){
		return;
	}
    insertNodeParams= {};
    insertNodeParams.workitemId= "";
	insertNodeParams.processId= "-1";
	insertNodeParams.nodeId= "start";
	insertNodeParams.currentUserId = $.ctx.CurrentUser.id;
	insertNodeParams.performer= $.ctx.CurrentUser.id;
	insertNodeParams.caseId= "";
	insertNodeParams.appName= appName;
	insertNodeParams.isForm= true;
	insertNodeParams.accountId= loginAccount;
	insertNodeParams.callback= insertNodeCallBack;
	insertNodeParams.summaryId= summaryId;
	insertNodeParams.affairId= "-1";
	insertNodeParams.isTemplete= "false";
	insertNodeParams.useNowexpirationTime= "true";
	insertNodeParams.SPK= "default";
	insertNodeParams.formRecordId = "";
	insertNodeParams.needValidateOnBeforeAdd = "false";
	insertNodeParams.needAddNodeDiagram = "true";
    insertNodeParams.changeNodeMessage = {};
    insertNodeParams.callBackFn = param.callBackFn;
	insertNodeParams.NPS= "form";
	
    if(param &&  param.isOperationDesignerModel){
        insertNodeParams.needAddNodeDiagram = "false";
        param.changeNodeMessage.NPS = "default";
        param.changeNodeMessage.appName = appName;
        param.changeNodeMessage.currentUserId = $.ctx.CurrentUser.id;
        param.changeNodeMessage.currentUserName = $.ctx.CurrentUser.name;
        insertNodeParams.changeNodeMessage = param.changeNodeMessage;
    }else{
        insertNodeParams.changeNodeMessage.NPS = "default";
        insertNodeParams.changeNodeMessage.appName= appName;
        insertNodeParams.changeNodeMessage.currentUserId = $.ctx.CurrentUser.id;
        insertNodeParams.changeNodeMessage.currentUserName = $.ctx.CurrentUser.name;
	}
    insertNodeParams.changeNodeMessage.isNiWen = true;
    insertNode(insertNodeParams);
}
function validateProcess(){
	//快速选人组件整理发送流程前的数据
    tidyDatas("process_info",defaultNodeName,defaultNodeLable);
	// 判断流程是否为空
	var process_lc = document.getElementById("process_info");
	var defaultPro = $("#process_info").attr("defaultValue");
	if (defaultPro==$.trim(process_lc.value)) {
	    $("#process_info").attr("value","");
	}
	var needCheckProcessXML = true;
	if((process_lc && process_lc.value=="")
	        || (needCheckProcessXML && (!$("#process_xml").val() && !$("#processId").val())) ){
//	    $.messageBox({
//	        'type' : 0,
//	        'title':$.i18n('system.prompt.js'),
//	        'msg' : $.i18n('collaboration.forward.workFlowNotNull'), // 流程不能为空
//	        'imgType':2,
//	        ok_fn : function() {
//                clickProcessInfoButton();// lilong 0327
//	    		// $("#process_info").click();
//	        }
//	      });
//		return true;
		//设置默认值
		var lineId = getUUID();
		var process_xml = '<ps> <p t="p" s="false" w="false" i="" n="" d="" u=""> <n i="start" n="'+$.ctx.CurrentUser.name+'" t="8" d="" x="0" y="0" q="" ncn="" ncn_i18n="" h="" g="" f="" b="normal"> <a k="" c="1" j="false" i="false" f="'+$.ctx.CurrentUser.id+'" g="user" h="false" d="'+$.ctx.CurrentUser.name+'" l="" m="" b="" vj="0" /> <s i="" n="" d="" t="17" l="" q="" p="" o="" u="-1" h="-1" v="-1" rs="" mu="1" w="-1" na="-1" nai="" nan="" na_b="0" na_i="0" k="" cy="" g="0" j="all" f="" fv="" FR="" DR="" s="success" m="false" ca="false" c="1" b="0" a="" tm="1" qid="" sid="" sa="0" md="" st="0" lk="0" oe="0" ft="0" ftv="100" mr="" /> </n> <n i="end" n="end" t="4" d="" x="2" y="0" q=""> <s i="" n="" d="" t="17" l="" q="" p="" o="" u="-1" h="-1" v="-1" rs="" mu="1" w="-1" na="-1" nai="" nan="" na_b="0" na_i="0" k="" cy="" g="0" j="all" f="" fv="" FR="" DR="" s="success" m="false" ca="false" c="1" b="0" a="" tm="1" qid="" sid="" sa="0" md="" st="0" lk="0" oe="0" ft="0" ftv="100" mr="" /> </n> <l i="'+lineId+'" n="" t="11" d="" k="start" j="end" o="" h="3" m="" e="" b="" a="" c="" /> </p> </ps>';
		var processInfo = [];
		processInfo[0] = "xml";
		processInfo[1] = process_xml;
		processInfo[2] = "";
		processInfo[3] = "";
		processInfo[4] = "{}";
		processInfo[5] = "{}";
		processInfo[6] = "";
		var tprocess_xml_input = $("#process_xml", window.document)[0];
		tprocess_xml_input.value = process_xml;
		initDialogDataToParentPage(processInfo, window, window);
		return false;
	}
}

function insertNodeCallBack(param){
	try {// 协同快速选人
			window.distroy_token = true;
			   //隐藏协同右侧的常用联系人
		   if(typeof(hideCommonContact) != "undefined"){
				hideCommonContact();
		   }
	} catch (e) {
	}
	hasAddNode = true;
	$("#process_info").val(param.workflowNodeInfo);
	var cu = $.ctx.CurrentUser;
	var options = {
			targetWin : getCtpTop(),
			valueWin : window,
			appName : appName,
			isTemplate : false,
			currentUserId : cu.id,
			currentUserName : cu.name,
			currentAccountName:cu.loginAccountName,
			flowPermAccountId:cu.loginAccount,
			processId : -1,
			defaultPolicyId : defaultPolicyId,
			defaultPolicyName : defaultPolicyName,
			callBackFn: insertNodeParams.callBackFn,
			scene : 1,
			SPK:"0",
			buttons:[{"id":"ok"}]
	};
    try{
        $("#courTrial").val("1");
        $("#processInfoValue").val($("#process_info").val());
    }catch (e){}
	showDiagram(options);
}

function createProcessXmlCallBack1(tWindow,res,appName,returnValueWindow,currentUserId,currentUserName,currentUserAccountName,
		  defaultPolicyId,flowPermAccountId,defaultPolicyName,SPK,NPS,policyObjArr,formAppId){
    if(res && res.obj && res.obj.length>0 && res.obj[0].length>0){
          var str = []
          ,isShowShortName = res.obj[2]
          ,policyId = defaultPolicyId
          ,policyName = defaultPolicyName
          ,formOperationPolicy = '0'
          ,flowType = res.obj[1]
          ,userId = ""
          ,userName = ""
          ,userType = ""
          ,userExcludeChildDepartment = ""
          ,accountId = ""
          ,accountName = ""
          ,workFlowContent = "";
          isShowShortName= isShowShortName==undefined?"":isShowShortName;

          var nodeIds = [], personArray = res.obj[0];

          var startX = 0;
          var startY = 0;
          var endX = 0;


          var isParallel = true;  //是否并行
          if(flowType == 0 || nodeIds.length == 1) { //串发(1个节点算串发)：两个节点之间创建线
               isParallel = false;
          }

          if(isParallel){
              startY = (personArray.length-1)/2;
              endX = 4;

          }else{
              startY = 0;
              endX = personArray.length+1
          }
          var endY = startY;
			if(!formAppId){
          	formAppId = "";
          }
          str.push("<ps>");
          str.push("<p s=\"" + isShowShortName + "\" u=\"\" y=\"0\" x=\"0\" i=\"\" n=\"\" d=\"\" t=\"\">");

          //开始节点
          str.push("<n m=\"0\" y=\""+startY+"\" x=\""+startX+"\" t=\"8\" d=\"\" n=\"" + currentUserName + "\" i=\"start\">");
          str.push("<a a=\"\" b=\"\" c=\"1\" d=\"\" e=\"\" f=\"" + currentUserId + "\" g=\"user\" i=\"false\" j=\"false\" k=\"\"/>");
          str.push("<s c=\"1\" r=\"\" e=\"\" f=\""+formAppId+"\" g=\"0\" j=\"multiple\" k=\"\" l=\"\" m=\"false\" s=\"success\" d=\"\" t=\"\" n=\"\" i=\""+policyId+"\"/>");
          str.push("</n>");

          //结束节点
          str.push("<n m=\"0\" y=\""+endY+"\" x=\""+endX+"\" t=\"4\" d=\"\" n=\"end\" i=\"end\">");
          str.push("<a a=\"\" b=\"\" c=\"1\" d=\"\" e=\"\" f=\"\" g=\"\" i=\"false\" j=\"false\" k=\"\"/>");
          str.push("<s c=\"1\" r=\"\" e=\"\" f=\"\" g=\"0\" j=\"multiple\" k=\"\" l=\"\" m=\"false\" s=\"success\" d=\"\" t=\"\" n=\""+policyName+"\" i=\""+policyId+"\"/>");
          str.push("</n>");


          for (var i=0, len=personArray.length; i<len; i++) {
              var person = personArray[i];

              var nodeId = getUUID()
              ,userId = person.id
              ,userName = person.name
              ,userType = person.type
              ,userExcludeChildDepartment = person.excludeChildDepartment
              ,accountId = person.accountId
              ,accountShortname = person.accountShortname || "";

              nodeIds.push(nodeId);
              
              var node_process_mode = "all";
              if(userType == 'Member'){
                  userType = 'user';
                  node_process_mode = "single"; 
              }
              userExcludeChildDepartment= userExcludeChildDepartment==undefined?false:userExcludeChildDepartment;
              var matchScope = 1;
              if(userType == "Post" && accountId == "-1730833917365171641"){ //判断是否是集团标准岗位，偷了个懒，直接比id
                  matchScope = 2; //集团标准岗，全集团范围内匹配
              }
              var nodePolicyName= policyName;
              var nodePolicyId= policyId;
              var nodeProcessMode= node_process_mode;
              if(typeof(policyObjArr)!='undefined' && policyObjArr[i]){
              	var policyObj= policyObjArr[i];
              	if(policyObj){
              		if(policyObj.nodePolicyName && policyObj.nodePolicyId){
              			nodePolicyName= policyObj.nodePolicyName;
              			nodePolicyId= policyObj.nodePolicyId;
              		}
              		if(policyObj.processMode){
              			nodeProcessMode= policyObj.processMode;
              		}
              	}
              }

              var nodeX = i+1;
              var nodeY = 0;

              if(isParallel) {
                  nodeX = 2;
                  nodeY = i;
              }

              str.push("<n a=\"1\"  y=\""+nodeY+"\" x=\""+nodeX+"\"  b=\"normal\" c=\"false\" l=\"1000\" e=\"0\" t=\"6\" d=\"\" n=\"" + escapeSpecialChar(userName) + "\" i=\"" + nodeId + "\">");
              str.push("<a a=\"" + escapeSpecialChar(accountShortname) + "\" b=\"" + accountId + "\" c=\"1\" d=\"" + escapeSpecialChar(userName) + "\" e=\"\" f=\"" + userId + "\" h=\"" + userExcludeChildDepartment + "\" g=\"" + userType + "\" i=\"false\" j=\"false\" k=\"roleadmin\"/>");
              str.push("<s c=\"" + matchScope + "\" r=\"\" e=\"\" f=\""+formAppId+"\" g=\"0\" j=\""+nodeProcessMode+"\" k=\"\" l=\"\" m=\"false\" s=\"success\" d=\"\" t=\"\" n=\""+nodePolicyName+"\" i=\""+nodePolicyId+"\"/>");
              str.push("</n>");

              if(i < 12){
                  if(i > 0){
                      workFlowContent += $.i18n('workflow.createProcessXml.common_separator_label');
                  }
                  var _text = userName;
                  if(accountShortname != null && accountShortname != "null" && accountShortname != "undefined" && accountShortname != ""){
                      _text = _text + "(" + accountShortname + ")";
                  }
                  _text += "("+policyName+")";
                  
                  workFlowContent += _text;
              }
          }

          if(flowType == 0 || nodeIds.length == 1){ //串发(1个节点算串发)：两个节点之间创建线
              str.push('<l a="" b="" c="" e="" m="" h="3" o="0" j="' + nodeIds[0] + '" k="start" t="11" d="" n="" i="' + getUUID() + '"/>');
              str.push('<l a="" b="" c="" e="" m="" h="3" o="0" j="end" k="' + nodeIds[nodeIds.length - 1] + '" t="11" d="" n="" i="' + getUUID() + '"/>');

              for(var i = 0; i < nodeIds.length - 1; i++) {
                  var f = nodeIds[i];
                  var t = nodeIds[i + 1];

                  str.push('<l a="" c="" b="" e="" m="" h="3" o="0" j="' + t + '" k="' + f + '" t="11" d="" n="" i="' + getUUID() + '"/>');
              }
          }else{ //并发：创建split\join
              var splitId = getUUID();
              var joinId = getUUID();

              str.push("<n o=\"\" p=\"true\" y=\""+startY+"\" x=\"1\" t=\"2\" d=\"\" n=\"split\" i=\""+ splitId +"\">");
              str.push("<s c=\"1\" r=\"\" e=\"\" f=\"\" g=\"0\" j=\""+node_process_mode+"\" k=\"\" l=\"\" m=\"false\" s=\"success\" d=\"\" t=\"\" n=\""+policyName+"\" i=\""+policyId+"\"/>");
              str.push("</n>");
              str.push("<n o=\"\" p=\"false\" y=\""+startY+"\" x=\"3\" t=\"2\" d=\"\" n=\"join\" i=\"" + joinId + "\">");
              str.push("<s c=\"1\" r=\"\" e=\"\" f=\"\" g=\"0\" j=\""+node_process_mode+"\" k=\"\" l=\"\" m=\"false\" s=\"success\" d=\"\" t=\"\" n=\""+policyName+"\" i=\""+policyId+"\"/>");
              str.push("</n>");

              str.push('<l a="" b="" c="" e="" m="" h="3" o="0" j="' + splitId + '" k="start" t="11" d="" n="" i="' + getUUID() + '"/>');
              str.push('<l a="" b="" c="" e="" m="" h="3" o="0" j="end" k="' + joinId + '" t="11" d="" n="" i="' + getUUID() + '"/>');

              for(var i = nodeIds.length - 1; i >= 0; i--) {
                  var nId = nodeIds[i];
                  str.push('<l a="" b="" c="" e="" m="" h="3" o="0" j="' + nId + '" k="' + splitId + '" t="11" d="" n="" i="' + getUUID() + '"/>');
                  str.push('<l a="" b="" c="" e="" m="" h="3" o="0" j="' + joinId + '" k="' + nId + '" t="11" d="" n="" i="' + getUUID() + '"/>');
              }
          }
          str.push("</p></ps>");
          var process_xml = str.join("");
          var processInfo = [];
          processInfo[0] = "xml";
          processInfo[1] = process_xml;
          processInfo[2] = workFlowContent;
          processInfo[3] = "";
          processInfo[4] = "{}";
          processInfo[5] = "{}";
          processInfo[6] = "";
          var tprocess_xml_input= $("#process_xml",returnValueWindow.document)[0];
          tprocess_xml_input.value=process_xml;
          initDialogDataToParentPage(processInfo,returnValueWindow,window);
      }
  }