(function($){
	$.i18n = function(key) {
		function sleep(milliseconds) {
			var start = new Date().getTime();
			for (var i = 0; i < 1e7; i++) {
				if ((new Date().getTime() - start) > milliseconds){
					break;
				}
			}
		}
		try {
			var msg  = '';
			var appId = getA8Top().APPID;
			if(window.localStorage){
				msg = window.localStorage.getItem('i18n_' + key);
				if(msg==null){
					var data = window.localStorage.getItem("i18n_DATA");
					if(data==null){
						$.ajax({
							url: "/seeyon/i18n_init_" + _locale +".js",
							async: false,
							beforeSend: CsrfGuard.beforeAjaxSend,
							dataType: "script"
						});
					}
					var k = '|_'+key+',';
					var firstIndex = data.indexOf(k);
					if(firstIndex>-1){
						var lastIndex = data.indexOf("_|",firstIndex );
						msg = data.substring(firstIndex + k.length,lastIndex);
						localStorage.setItem('i18n_' + key,msg);
					}
					data = null;
				}
			}else{
				if(!CTPLang){
					$.ajax({
						url: "/seeyon/i18n_" + _locale +".js",
						async: false,
						beforeSend: CsrfGuard.beforeAjaxSend,
						dataType: "script"
					});
				}
				var lang = CTPLang[_locale];
				if (!lang)
					return key;
				var msg = lang[key+_editionI18nSuffix.toUpperCase()];
				if(!msg){
					msg = lang[key+_editionI18nSuffix.toLowerCase()];
				}
				if(!msg){
					msg = lang[key];
				}
			}
			if (msg && arguments.length > 1) {
				var messageRegEx_0 = /\{0\}/g;
				var messageRegEx_1 = /\{1\}/g;
				var messageRegEx_2 = /\{2\}/g;
				var messageRegEx_3 = /\{3\}/g;
				var messageRegEx_4 = /\{4\}/g;
				var messageRegEx_5 = /\{5\}/g;
				var messageRegEx_6 = /\{6\}/g;
				var messageRegEx_7 = /\{7\}/g;
				var messageRegEx_8 = /\{8\}/g;
				var messageRegEx_9 = /\{9\}/g;
				var messageRegEx_10 = /\{10\}/g;
				var messageRegEx_11 = /\{11\}/g;
				var messageRegEx_12 = /\{12\}/g;
				var messageRegEx_13 = /\{13\}/g;
				var messageRegEx_14 = /\{14\}/g;
				var messageRegEx_15 = /\{15\}/g;
				for ( var i = 0; i < arguments.length - 1; i++) {
					var regEx = eval("messageRegEx_" + i);
					var repMe = "" + arguments[i + 1];
					if (repMe.indexOf("$_") != -1) {
						repMe = repMe.replace("$_", "$$_");
					}
					msg = msg.replace(regEx, repMe);
				}
			}

			if (msg==undefined || msg == null){
				msg = key;
			}
			return msg;
		} catch (e) {
		}

		return "";
	}
})(jQuery);

var initDisplayColumnArr = new Array();
var initDisplayColumnLabelArr = new Array();
var reNameRecordArray = new Array();//重命名修改记录
var elementListArray = new Array();

/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadData();
});

/**
 * 
 */
function loadData() {
	//获取选择情况
	var conditionColumnArr = initW.getConditionColumnArr();
	var conditionColumnLabelArr = initW.getConditionColumnLabelArr();
	
	//第一次加载添加默认显示的元素
	if(initW.getIsFirstLoad()&&conditionColumnArr.length==0){
		if(initW.getFromPageType() == "edocStat"){//来自公文统计调用 
			conditionColumnArr.push("subject");//公文标题 
			conditionColumnLabelArr.push($.i18n("edoc.element.subject"));
			if(initW.getListPageType()=="listRecRegister"){//收文登记簿
				conditionColumnArr.push("doc_mark");//内部文号
				conditionColumnLabelArr.push($.i18n("govdoc.serialNo.label"));
				
				conditionColumnArr.push("receipt_date");//来文日期 
				conditionColumnLabelArr.push($.i18n("edoc.element.communication.date"));
			}else{//发文登记簿、签报登记簿
				conditionColumnArr.push("doc_mark");//公文文号
				conditionColumnLabelArr.push($.i18n("govdoc.docMark.label"));
				
				conditionColumnArr.push("createdate");//拟文日期 
				conditionColumnLabelArr.push($.i18n("edoc.edoctitle.createDate.label"));	
			}
		}else{//公文查询调用
			conditionColumnArr.push("govdocType"); //类别
			conditionColumnLabelArr.push($.i18n("govdoc.query.govdocType"));
			
			conditionColumnArr.push("subject"); //公文标题
			conditionColumnLabelArr.push($.i18n("edoc.element.subject"));
			
			conditionColumnArr.push("serial_no");//内部文号
			conditionColumnLabelArr.push($.i18n("govdoc.serialNo.label"));
			
			conditionColumnArr.push("doc_mark");//公文文号
			conditionColumnLabelArr.push($.i18n("govdoc.docMark.label"));
			
			conditionColumnArr.push("send_type");//行文类型
			conditionColumnLabelArr.push($.i18n("edoc.element.sendtype"));
			
			conditionColumnArr.push("doc_type");//公文类型
			conditionColumnLabelArr.push($.i18n("edoc.element.doctype"));
		
			conditionColumnArr.push("createdate");//发起日期
			conditionColumnLabelArr.push($.i18n("govdoc.query.startDate"));
			
			conditionColumnArr.push("create_person");//拟稿人
			conditionColumnLabelArr.push($.i18n("edoc.edoctitle.createPerson.label"));
			
			conditionColumnArr.push("send_unit");//发文单位
			conditionColumnLabelArr.push($.i18n("govdoc.issue.unit"));
			
			conditionColumnArr.push("send_to");//主送单位
			conditionColumnLabelArr.push($.i18n("edoc.element.sendtounit"));
			
			conditionColumnArr.push("send_department");//发文部门
			conditionColumnLabelArr.push($.i18n("govdoc.query.send.department"));
			
			conditionColumnArr.push("issuer");//签发人
			conditionColumnLabelArr.push($.i18n("edoc.element.issuer"));
			
			conditionColumnArr.push("signing_date");//签发日期
			conditionColumnLabelArr.push($.i18n("govdoc.date.issuance")); 
		}
	}else{
		//添加固定类别
		if(initW.getFromPageType() == "edocSearch"){
			conditionColumnArr.unshift("govdocType");
			conditionColumnLabelArr.unshift($.i18n("govdoc.query.govdocType"));
		}
	}
	
	//右边选择框的双击事件
	$('#menuTargetSelect').dblclick(function() {
		rightdbclick();
	});
	//存放初始元素名称
	initMenuSourceElementArray();
	
	//去除已经选择的公文元素
	for(i=0; i<conditionColumnArr.length; i++) {
		$("#menuSourceSelect").find("option").each(function() {
			var _this = $(this);
			if(_this.val() == conditionColumnArr[i]) {
				_this.remove();
			}
		});
	}
	
	for(i=0; i<conditionColumnArr.length; i++) {
		$("#menuTargetSelect").append("<option value='"+conditionColumnArr[i]+"'>"+conditionColumnLabelArr[i]+"</option>");
	}
	
	var source = document.getElementById("menuSourceSelect");
	for(i=0; i<source.options.length; i++) {
		initDisplayColumnArr[i] = source.options[i].value;
		initDisplayColumnLabelArr[i] = source.options[i].text;
	}
}


//右边选择框的双击事件
function rightdbclick() {
	var selectObj = document.getElementById("menuTargetSelect");
    if (selectObj.selectedIndex < 0){
		return;
    }
    //选中的值
    var _fieldName =  $(selectObj).find("option:selected").val();
    var _fieldValue = $(selectObj).find("option:selected").text(); 
    var title = $.i18n("govdoc.query.rename")
    var	 url = edocListURL + "?method=openInputChooseRename&fieldName=" + _fieldName +"&fieldValue=" +escapeStringToHTML(encodeURIComponent(_fieldValue))+"&date="+new Date().getTime();
	
    var dialog = getA8Top().$.dialog({
			id:"conditionQueryInputChooseRenameDialog",
		    url: url,
		    title : title,
			width:450,
		    height:300,
			targetWindow:getA8Top(),
			transParams:{'parentWin':window},
			buttons : [{
			   text : $.i18n("common.button.ok.label"),
			   id:"sure",
			   isEmphasize: true,
			   handler : function() {
				   var result = dialog.getReturnValue();
				      if(result=='true'){
				    	   dialog.close();
                   }else if(result=='false'){
				      }else{
				    	  alert(result);
				    	  //$.alert(result);
				      }
				   
			      }
			    }, {
			      text : $.i18n("common.button.cancel.label"),
			      id:"exit",
			      handler : function() {
			      	dialog.close();
			      }
			    }]
		 });
		return dialog;
}

//重命名方法回调
function reloadRightSelectArea(result){
	var fieldName = result["_fileName"];
	var fieldValue = result["_fileValue"];
	
	//窗口右侧选中的项
	var selectObj = document.getElementById("menuTargetSelect");
    if (selectObj.selectedIndex < 0){
		return;
    }
	var slectData = selectObj.options[selectObj.selectedIndex];
	
	var reNameObj = new Object();
	reNameObj.sourceFieldName = slectData.value;
	reNameObj.sourceFieldValue = slectData.text;
	reNameObj.newValue = fieldValue;
	reNameRecordArray.push(reNameObj);
	
	$(slectData).text(fieldValue)
	$(slectData).val(fieldName);
	//slectData.text = fieldValue;
	//slectData.value = fieldName;

}

function setDisplayCol(){
	var target = document.getElementById("menuTargetSelect");
	var opvalue = "";
	var opname = "";
	for(i=0; i<target.options.length; i++) {
		if(target.options[i].value != "govdocType"){
			opvalue += target.options[i].value+",";
			opname += target.options[i].text+",";
		}
	}
	if(opvalue.lastIndexOf(",") == opvalue.length-1) {
		opvalue = opvalue.substring(0,opvalue.length-1);
		opname = opname.substring(0,opname.length-1);
	}
	initW.returnListBindEnum(listEnum);
	initW.reloadConditionColumn(opvalue, opname);
	
	commonDialogClose('win123');
}


//按公文元素关键字查询公文元素
function doSearch() {
	var edocSettingSearchKeyWord = $("#edocSettingSearchKeyWord").val();
	var target = document.getElementById("menuTargetSelect");
	var source = document.getElementById("menuSourceSelect");
	source.options.length = 0;
	
	for(i=0; i<initDisplayColumnArr.length; i++) {
		if(initDisplayColumnLabelArr[i].indexOf(edocSettingSearchKeyWord) >= 0) {
			var flag = true;
			for(var j=0; j<target.options.length; j++) {
				if(target.options[j].value == initDisplayColumnArr[i]) {
					flag = false;
					break;
				}
			}
			if(flag) {
				$("#menuSourceSelect").append("<option value='"+initDisplayColumnArr[i]+"'>"+initDisplayColumnLabelArr[i]+"</option>");	
			}
		}
	}
}

//判断选择内容是否超过20个
function addThisItemCheck(){
	var source = document.getElementById("menuSourceSelect");
	var target = document.getElementById("menuTargetSelect");
	
	var count= 0;
	//备选框中选择了多少个
	for(i=0;i<source.options.length;i++){  
		  if(source.options[i].selected){
		   	count++;
		  }
	}
	//已选框中选择了多少个
	var selectLength = target.options.length ;
	//如果已选框和备选框选择共超过20个，在已选框中只显示20个
	if(count+selectLength > 20) {
	 	//还可以选择多少个，插入可以选择的个数
		alert(v3x.getMessage("govdocLang.alert_show_morethan20"));
	} else if(count + selectLength <= 20) {
		
		addThisItem('menu');
	}
}

//把左侧显示的元素存到数据，以便重名后移到左边能显示原来的元素名称
function initMenuSourceElementArray(){
	var source = document.getElementById("menuSourceSelect");
	for(i=0;i<source.options.length;i++){  
		var sourceObj = new Object();
		sourceObj.text = source.options[i].text;
		sourceObj.value = source.options[i].value;
		elementListArray.push(sourceObj);
	}
}

//判断右侧选择的是否是分类
function removeThisItemCheck(){
	var selectObj = document.getElementById("menuTargetSelect");
    if (selectObj.selectedIndex < 0){
		return;
    }
	var slectData = selectObj.options[selectObj.selectedIndex];
	if(slectData.value == "govdocType"){
		alert($.i18n("govdoc.query.category_is_need_condition_not_can_removed"));
	}else{
		removeThisItem('menu');
		//重命名移除到左边恢复默认元素名
		if(reNameRecordArray.length>0){
			for(i=0;i<elementListArray.length;i++){
				 var sourceObj = elementListArray[i];
				 if(sourceObj.value == slectData.value){
						for(var j=0;j<reNameRecordArray.length;j++){
					       var reNameObj = reNameRecordArray[j];
					       if(reNameObj.newValue != sourceObj.text){
					    	   var source = document.getElementById("menuSourceSelect");
					    	   for(var m=0;m<source.length;m++){
					    		   var sObj = source.options[m];
					    		   if(sObj.value == sourceObj.value){
					    			   $(sObj).text(sourceObj.text);
					    			   break;
					    		   }
					    	   }
						   }
						}	 
				  }
			 }
					
		}
	}
}