/**
 * 页面加载初始化
 */
$(document).ready(function() {
	loadUE();
	loadData();
	setListTableUI();
	listAddWaterMark("queryResult");
});

/**
 * 加载页面布局
 */
function loadUE() {
	new MxtLayout({
		'id' : 'layout',
		'northArea' : {
			'id' : 'north',
			'height' : 0,
			'sprit' : false,
			'border' : false
		},
		'centerArea' : {
			'id' : 'center',
			'border' : false,
			'minHeight' : 20
		}
	});
	
	$(window).resize(function() {
		setListTableUI();
	});
}

/**
 * 重新调整grid的布局
 */
function setListTableUI() {
	var cHi = parent.getReslutHeihgt();
	var tbHi = 0;
    //var cHi = $('#center').height();
    //var tbHi = $('#toolbars').height();
    var hHi = $('.hDiv').height();
    var pHi = $('.pDiv').height();
    $('.flexigrid .bDiv').height(cHi - tbHi - hHi - pHi - 3);
}


/**
 * 列表数据加载
 */
function loadData() {
	var colModels = new Array();
	var displayArr = parent.getDisplayColumnArr();
	if(displayArr.length > 0 && parent.getCustomSearchCheck()==true) {//查询自定义
		var displayNameArr = parent.getDisplayColumnLabelArr();
		var elementMap = getElementMap();
		for(var i=0; i<displayArr.length; i++) {
			var displayField = elementMap.get(displayArr[i]);
			if(displayField=="subject"){
				colModels.push({display : displayNameArr[i], name : displayField, sortable : true, width : '33%' });	
			}else if(displayField=="packdate"){
				colModels.push({display : displayNameArr[i], name : "packTime", sortable : true, width : '12%' });
			}else{
				colModels.push({display : displayNameArr[i], name : displayField, sortable : true, width : '12%' });	
			}
		}
	} else {
		// 密级
		colModels.push({display : $.i18n("govdoc.secretLevel.label"), name : 'secretLevel', sortable : true, width : '9%' });
		// 公文标题
		colModels.push({display : $.i18n("common.subject.label"), name : 'subject', sortable : true, width : '23%' });
		// 公文文号
		colModels.push({display : $.i18n("govdoc.docMark.label"), name : 'docMark', sortable : true, width : '12%' });
		if(govdocType == 1 || govdocType == 3) {//发文/签报
			// 主送单位
			colModels.push({display : $.i18n("edoc.element.sendtounit"), name : 'sendTo', sortable : true, width : '30%' });
			// 签发人
			colModels.push({display : $.i18n("edoc.element.issuer"), name : 'issuer', sortable : true, width : '10%' });
			// 签发日期
			colModels.push({display : $.i18n("edoc.element.sendingdate"), name : 'signingDate', sortable : true, width : '10%' });
		} else if(govdocType == "2,4") {//收文
			//来文单位
			colModels.push({display : $.i18n("edoc.edoctitle.fromUnit.label"), name : 'sendUnit', sortable : true, width : '15%' });
			//登记人
			colModels.push({display : $.i18n("edoc.edoctitle.regPerson.label"), name : 'createPerson', sortable : true, width : '10%' });
			//登记日期
			colModels.push({display : $.i18n("edoc.edoctitle.regDate.label"), name : 'createTime', sortable : true, width : '10%' });
		}
		if(govdocType != "2,4") {//全部/发文/签报
			//拟稿人
			colModels.push({display : $.i18n("edoc.edoctitle.createPerson.label"), name : 'createPerson', sortable : true, width : '10%' });
			//colModels.push({display : $.i18n("edoc.edoctitle.createPerson.label"), name : 'startUserName', sortable : true, width : '10%' });
		}
		// 公文种类
		colModels.push({display : $.i18n("edoc.element.doctype"), name : 'docType', sortable : true, width : '9%' });
		// 行文类型
		colModels.push({display : $.i18n("edoc.element.sendtype"), name : 'sendType', sortable : true, width : '9%' });
		// 内部文号
		colModels.push({display : $.i18n("govdoc.serialNo.label"), name : 'serialNo', sortable : true, width : '12%' });
		if(govdocType != "2,4") {//全部/发文/签报
			//发文单位
			colModels.push({display : $.i18n("edoc.element.sendunit"), name : 'sendUnit', sortable : true, width : '15%' });
		}
		// 是否归档
		colModels.push({display : $.i18n("govdoc.canArchive.label"), name : 'hasArchive', sortable : true, width : '9%' });
		// 归档路径
		colModels.push({display : $.i18n("govdoc.archiveName.label"), name : 'archiveName', sortable : true, width : '10%' });
		// 印发份数
		colModels.push({display : $.i18n("govdoc.copies.label"), name : 'copies', sortable : true, width : '9%' });
	}
	
	grid = $('#queryResult').ajaxgrid({
		colModel : colModels,
		click : dbclickRow,
		render : rend,
		height : 200,
		showTableToggleBtn : true,
		parentId : $('.layout_center').eq(0).attr('id'),
		vChange : false,
		vChangeParam : {
			overflow : "hidden",
			autoResize : true
		},
		isHaveIframe : false,
		slideToggleBtn : false,
		showToggleBtn: false,
		customize: false,
		onSuccess:listCallBack,
		onNoDataSuccess:listCallBack,
		managerName : "govdocListManager",
		managerMethod : "findQueryResultList"
	});

	var o = parent.getConditionObj();
	//自定义查询中是否有list元素
	if(displayArr.length > 0){
		var HasList = checkHasListElement(displayArr);
		if(HasList=="true"){
			o.isNeedSearchSummaryExtendOnlyInDisplay = "true";
		}
	}
	searchByCondition(o);
}
function listCallBack(){
	try{
		parent.searching = false;
	}catch(e){}
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
    $("#queryResult").ajaxgridLoad(o);
}

/**
 * 列表数据回填
 * @param txt
 * @param data
 * @param r
 * @param c
 * @param col
 * @returns
 */
function rend(txt, data, r, c, col) {
	if (null == txt) {// 修正 如果是未讀，那麼會顯示null字符串
		txt = "";
	}
	if (col.name === "subject") {// 标题
		txt = getListSubjectTxt(txt, data, true, true, true, true, true, true, true);
	}else if(col.name === "signingDate"){
		if(data.signingDate!=null && data.signingDate!=""){
			if(data.signingDate.split(" ").length > 1){
				txt = data.signingDate.split(" ")[0];
			}
		}
	}
	else if (col.name === "hasArchive") {// 是否归档
		if (txt == true) {
			txt = $.i18n('govdoc.canArchive.label.yes');
		} else {
			txt = $.i18n('govdoc.canArchive.label.no');
		}
	}

	return txt;
}

//双击事件
function dbclickRow(data, rowIndex, colIndex) {
	if (colIndex == 11) {
		return;
	}
	// 取消加粗
	cancelBold("listQuery", rowIndex);

	if (!isAffairValid(data.affairId)) {
		reloadListGrid();
		return;
	}
	
	var _url = getListClickUrl(data, "glwd");
	if(!_url) {
		return;
	}
	
	var _title = data.subject;
	openGovdocDialog(_url, escapeStringToHTML(_title));
	grid.grid.resizeGridUpDown('down');
	
}
