/**
 * 页面加载初始化
 */
$(document).ready(function() {
	setHistorySerachCondition();
	loadData();
	if(!isFromSection) {
		loadToolbar();
		loadUE();
		loadEvent();
		listAddWaterMark('listSendRegister');
	}
});

/**
 * 列表数据加载
 */
function loadData() {
	var colModels = new Array();
	//自定义
	var displayArr = getDisplayColumnArr();
	if(displayArr.length > 0) {//查询自定义
		var displayNameArr = getDisplayColumnLabelArr();
		var elementMap = getElementMap();
		for(var i=0; i<displayArr.length; i++) {
			var displayField = elementMap.get(displayArr[i]);
			if(displayField=="subject"){
				colModels.push( {
					display :displayNameArr[i] ,// 公文标题
					id : displayField,
					name : displayField,
					width : '33%',
					sortable : true,
					align : 'left',
					hide : false
				});
			}else{
				colModels.push( {
					display :displayNameArr[i] ,
					id : displayField,
					name : displayField,
					width : '12%',
					sortable : true,
					align : 'left',
					hide : false
				});
			}
		}
	}else{
		colModels.push( {
			display : $.i18n("edoc.element.subject"),// 公文标题
			id : 'subject',
			name : 'subject',
			width : '33%',
			sortable : true,
			align : 'left',
			hide : false
		}); 
		colModels.push( {
			display : $.i18n('govdoc.element.senddepartment3'),// 发文部门
			name : 'sendDepartment',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : !isSignReportBool
		});
		colModels.push( {
			display : $.i18n('edoc.edoctitle.createDate.label'),// 拟文日期
			name : 'startTime',
			width : '10%',
			sortable : true,
			sortType : "date",
			align : 'left',
			dataType : "date",
			hide : !isSignReportBool
		});	
		colModels.push( {
			display : $.i18n('edoc.element.wordno.label'),// 公文文号
			name : 'docMark',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : false
		});
		colModels.push( {
			display : $.i18n('govdoc.currentNodesInfo.label'),// 当前待办人
			name : 'currentNodesInfo',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : isSignReportBool
		});
	    colModels.push( {
	    	display : $.i18n('govdoc.element.leaderCommondSort.label'),//领导批示编号
	    	name : 'leaderCommondNo',
	    	width : '10%',
	    	sortable : true,
	    	align : 'left',
	    	hide : false
	    });
		colModels.push( {
			display : $.i18n('edoc.element.wordinno.label'),// 内部文号
			name : 'serialNo',
			width : '10%',
			align : 'left',
			sortable : true,
			hide : false
		});
		colModels.push( {
			display : $.i18n('edoc.element.sendtounit'),// 主送单位
			name : 'sendTo',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : isSignReportBool
		});
		colModels.push( {
			display : $.i18n('govdoc.element.doctype2'),// 公文种类
			name : 'docType',
			width : '10%',
			sortable : true,
			align : 'left',
			//codecfg : "codeId:'edoc_unit_level'",
			hide : isSignReportBool
		});
		colModels.push( {
			display : $.i18n('edoc.element.issuer'),// 签发人
			name : 'issuer',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : false
		});
		colModels.push( {
			display : $.i18n('edoc.element.sendingdate'),// 签发日期
			name : 'signingDate',
			width : '10%',
			sortable : true,
			sortType : "date",
			dataType : "date",
			align : 'left',
			hide : false
		});
		colModels.push( {
			display : $.i18n('govdoc.element.packTime'),// 分送日期
			name : 'packTime',
			width : '10%',
			sortable : true,
			sortType : "date",
			align : 'left',
			dataType : "date",
			hide : isSignReportBool
		});	
		colModels.push( {
			display : $.i18n('edoc.element.author'),// 拟稿人
			name : 'createPerson',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : !isSignReportBool
		});
		colModels.push({
			display : $.i18n('govdoc.stat.flowstat.label'),//流转状态
			name:'summaryTransferStatusName',
			width:'10%',
			sortable: true,
			align: 'left',
			hide: isSignReportBool
		});
		colModels.push( {
			display : $.i18n('edoc.element.review'),// 复核人
			name : 'review',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : true
		});
		colModels.push( {
			display : $.i18n('edoc.element.sendunit'),// 发文单位
			name : 'sendUnit',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : true
		});
		colModels.push( {
			display : $.i18n('edoc.element.copytounit'),// 抄送单位
			name : 'copyTo',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : true
		});
		colModels.push( {
			display : $.i18n('edoc.element.copies'),// 印发份数
			name : 'copies',
			width : '10%',
			sortable : true,
			align : 'left',
			sortType : "number",
			hide : true
		});
		colModels.push( {
			display : $.i18n('edoc.element.secretlevel.simple'),// 密级
			name : 'secretLevel',
			width : '10%',
			sortable : true,
			align : 'left',
			codecfg : "codeId:'edoc_secret_level'",
			hide : true
		});
		colModels.push( {
			display : $.i18n('edoc.element.keepperiod'),// 保密期限
			name : 'keepPeriodTxt',
			width : '10%',
			sortable : true,
			align : 'left',
			hide : true
		});
		colModels.push( {
			display : $.i18n('edoc.element.urgentlevel'),// 紧急程度
			name : 'urgentLevel',
			width : '10%',
			sortable : true,
			align : 'left',
			codecfg : "codeId:'edoc_urgent_level'",
			hide : true
		});
	}
    if(isFromSection) {//栏目查看的情况不初始化工具栏
        $("#layout_north").hide();
        $("#tabs").hide()
        $("#center").css("top","0").css("height","100%");
        $("#northSp_layout").hide();
        $("#toolbars").hide();
    }
    //重新加載grid
    if(grid != undefined){
    	$("#"+grid.p["id"]).remove();
    	var gridArea = document.getElementById('gridTableArea');
    	gridArea.innerHTML="<table class='flexme3' id='listSendRegister'></table>";
    }
	grid = $('#listSendRegister').ajaxgrid({
		colModel : colModels,
		click : dbclickRow,
		render : rend,
		height : 200,
		showTableToggleBtn : true,
		parentId : $('.layout_center').eq(0).attr('id'),
		vChange : false,
		vChangeParam : {
			overflow : "hidden",
			autoResize : true
		},
		isHaveIframe : false,
		slideToggleBtn : false,
		managerName : "govdocListManager",
		managerMethod : "findSendRegisterList",
        usepager : !isFromSection
	});
	
	
}

/**
 * 重新加载列表
 */
function searchByCondition(o) {
	//自定义查询中是否有list元素
	var displayArr = getDisplayColumnArr();
	if(displayArr.length > 0){
		var HasList = checkHasListElement(displayArr);
		if(HasList=="true"){
			o.isNeedSearchSummaryExtendOnlyInDisplay = "true";
		}
	}
    $("#listSendRegister").ajaxgridLoad(o);
    //公文统计簿在上部分查询条件较多，底部grid区域较小时，弹出的列表显示、隐藏视图高度过低时，无法完全显示出列表项
    var nHi = $('.nDiv').height();
    if(nHi!= null && nHi<80){
    	$('.flexigrid .nDiv').height(80);
    }
    //end
}

/**
 * 列表数据回填
 * @param txt
 * @param data
 * @param r
 * @param c
 * @param col
 * @returns
 */
function rend(txt, data, r, c, col) {
	if (null == txt) {// 修正 如果是未讀，那麼會顯示null字符串
		txt = "";
	}

	if (col.name === "subject") {// 标题
		txt = getListSubjectTxt(txt, data, true, true, true, true, true, true, true);
	} else if(col.name === "startUserName") {//发起人
		txt = getListRedColorTxt(txt, data);
	} else if(col.name === "signingDate" || col.name === "packTime") {//签发日期/分送日期
		if(txt != null && txt.length > 10) {
			txt = txt.substring(0, 10); 
		}
	}
	else if (col.name === "hasArchive") {// 是否归档
		if (txt == true) {
			txt = $.i18n('govdoc.canArchive.label.yes');
		} else {
			txt = $.i18n('govdoc.canArchive.label.no');
		}
	}
	return txt;
}
